/*
This script file contains the demo cut-scenes which are 
accessed from the main menu.
*/
var DoneTextScript = "";

function CutSceneMenu()
{
	while(AreKeysLeft())
	{
	GetKey();
	}
var selection = 0;
//var top_selection = 0;

FlipScreen();
  while (true) 
  {
		window_style.drawWindow(10, 10, 200, 7*20);

		// Menu items

		font.drawText(20,20, "Scene 1");
		font.drawText(20,40, "Scene 2");
		font.drawText(20,60, "Scene 3");
		font.drawText(20,80, "Mock Battle");
		font.drawText(20,100, "Scene 4");
		font.drawText(20,120, "Scene 5");
		font.drawText(20,140, "Mock Battle #2");
		font.drawText(20,160, "Exit");

		// Selection arrow
		font.drawText(10, (selection + 1) * 20, "-");

		FlipScreen();

		while (AreKeysLeft()) 
		{
			switch (GetKey()) 
			{
				case KEY_ENTER: 
				{
					if (selection == 0)
					{
					CutScene1();
					}
					else if (selection == 1)
					{
					CutScene2();
					}
					else if (selection == 2)
					{
					CutScene3();
					}
					else if (selection == 3)
					{
					CutScene4();
					}
					else if (selection == 4)
					{
					CutScene5();
					}
					else if (selection == 5)
					{
					CutScene6();
					}
					else if (selection == 6)
					{
					CutScene7();
					}
					else
					{
					Menu();
					}
					return;
				}

				case KEY_ESCAPE: 
				{
					if (first == true)
					{
					Menu();
					}
				return;
				}

				case KEY_DOWN: 
				{
					if (selection < 7) 
					{
					selection++;
					}
				break;
				}

				case KEY_UP: 
				{
					if (selection > 0) 
					{
					selection--;
					}
				break;
				}
			}
		}
  }
}

function CutScene1()
{
LoadMap("Castle3s");
Advancing = false;
StandardView();
SetScale(.25);
x_angle -= 2*3.14159;
y_angle -= 2*3.14159;
TiltAmount = 0;
RearrangeAngle();
LoadSpriteSetInfo(2, "male1");
LoadSpriteSetInfo(3, "cloud");
LoadSpriteSetInfo(4, "elmdor");

//36 nw
//32 nw
//28 ne

//set sprites
Sprite[1].direction = 8; //The direction the sprite is physically facing on the screen.
Sprite[1].fdir = 4;//the direction the sprite is facing (with reference to direction "d1");
Sprite[1].frame = 1;
Sprite[1].spriteset = 2;
Sprite[1].xoff = 14;//SpriteSet[Sprite[1].spriteset][1][1].width/2;
Sprite[1].yoff = 20;//SpriteSet[Sprite[1].spriteset][1][1].height-20;
Sprite[1].yoff2 = 0;
Sprite[1].xadd = 0;
Sprite[1].yadd = 0;
Sprite[1].zadd = 0;
Sprite[1].cube = 36;
Sprite[1].advance = false;
Cube[36].sprite = 1;

Sprite[2].direction = 8; //The direction the sprite is physically facing on the screen.
Sprite[2].fdir = 4;//the direction the sprite is facing (with reference to direction "d1");
Sprite[2].frame = 1;
Sprite[2].spriteset = 2;
Sprite[2].xoff = 14;//SpriteSet[Sprite[1].spriteset][1][1].width/2;
Sprite[2].yoff = 20;//SpriteSet[Sprite[1].spriteset][1][1].height-20;
Sprite[2].yoff2 = 0;
Sprite[2].xadd = 0;
Sprite[2].yadd = 0;
Sprite[2].zadd = 0;
Sprite[2].cube = 32;
Sprite[2].advance = false;
Cube[32].sprite = 2;

Sprite[3].direction = 7; //The direction the sprite is physically facing on the screen.
Sprite[3].fdir = 3;//the direction the sprite is facing (with reference to direction "d1");
Sprite[3].frame = 1;
Sprite[3].spriteset = 2;
Sprite[3].xoff = 14;//SpriteSet[Sprite[2].spriteset][1][1].width/2;
Sprite[3].yoff = 20;//SpriteSet[Sprite[2].spriteset][1][1].height-20;
Sprite[3].yoff2 = 0;
Sprite[3].xadd = 0;
Sprite[3].yadd = 0;
Sprite[3].zadd = 0;
Sprite[3].cube = 28;
Cube[28].sprite = 3;

Sprite[4].direction = 3; //The direction the sprite is physically facing on the screen.
Sprite[4].fdir = 2;//the direction the sprite is facing (with reference to direction "d1");
Sprite[4].frame = 3;
Sprite[4].spriteset = 2;
Sprite[4].xoff = 14;//SpriteSet[Sprite[1].spriteset][1][1].width/2;
Sprite[4].yoff = 20;//SpriteSet[Sprite[1].spriteset][1][1].height-20;
Sprite[4].yoff2 = 0;
Sprite[4].xadd = 0;
Sprite[4].yadd = 0;
Sprite[4].zadd = 0;
Sprite[4].cube = 32;
Sprite[4].advance = false;
Sprite[4].cube = -1;
Cube[113].sprite = -1;

Cube[31].sprite = -1;

Foreground = false;
//StandardView();
CenterCamera(-2,-2,-2);

SetMapDelayScript(1, "action", "CutScene1_FadeIn();");
NextFrame(false, false);
CutSceneMenu();
}

function CutScene1_FadeIn()
{
SpanAll(true, 220,-2,-2,-2,Cube[65].x+.5,Cube[65].y + .5,Cube[65].z+Cube[65].height, 11*3.14159/6, .75, .75)

	for (i=0; i<200; i++)
	{
	SetMapDelayScript(i, "draw", "Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0," + (255 - Math.floor(i*255/100)) + "));");
	}
	SetMapDelayScript(250, "action", "CutScene1_1();");
}

function CutScene1_1()
{
//Sprite[3].advance = true;
Sprite[3].direction = 6;
Sprite[3].frame = 1;
SetMapDelayScript(20, "action", "Sprite[3].advance = true;Sprite[3].direction = 6;Sprite[3].frame = 1;");
SetMapDelayScript(30, "action", "CutScene1_2();");
}

function CutScene1_2()
{
Sprite[3].advance = true;
Sprite[3].direction = 3;
Sprite[3].frame = 3;


MoveSprite(3, "se", false);
MoveSprite(3, "se", false);
MoveSprite(3, "sw", false);
SetMapDelayScript(1, "action", "MoveSprite(3, \"sw\", false,true);");
SetMapDelayScript(MS+1, "action", "MoveSprite(3, \"sw\", false,true);");
SetMapDelayScript(MS*2+1, "action", "MoveSprite(3, \"sw\", false,true);");
SetMapDelayScript(MS*3+1, "action", "MoveSprite(3, \"sw\", false,true);");
SetMapDelayScript(MS*4+1, "action", "MoveSprite(3, \"sw\", false,true);");
SetMapDelayScript(MS*5+1, "action", "MoveSprite(3, \"sw\", false,true);");
SetMapDelayScript(MS*6+1, "action", "MoveSprite(3, \"sw\", false,true);");
SetMapDelayScript(MS*6+2, "action", "Cube[Sprite[3].cube].sprite = -1; Sprite[3].cube = undefined;");

CenterCameraTo(Cube[14].x+.5,Cube[14].y+.5,Cube[14].z+Cube[14].height, true, 5.75);

SetMapDelayScript(MS*8+1, "action", "RotateCamera(2*-3.1415926/6, true, true, Cube[14].x+.5,Cube[14].y+.5,Cube[14].z+Cube[14].height,true);");
SetMapDelayScript(MS*9+1, "action", "CutScene1_3();");
}

function CutScene1_3()
{
Cube[78].pic2 = 22;
Cube[77].pic2 = 21;
//78
//77
SetMapDelayScript(20, "action", "Sprite[3].direction = 6; Sprite[3].fdir = 1; Sprite[3].frame = 1;Sprite[3].spriteset = 3;Sprite[3].xoff = 14;Sprite[3].yoff = 20;Sprite[3].cube = 70;Cube[70].sprite = 3;Sprite[3].advance = false;");
SetMapDelayScript(40, "action", "Cube[78].pic2 = 10; Cube[77].pic2 = 9;");
SetMapDelayScript(60, "action", "CutScene1_4();");
}

function CutScene1_4()
{
Sprite[3].advance = true;
MoveSprite(3, "sw", false);
MoveSprite(3, "sw", false);
MoveSprite(3, "sw", false);
SetMapDelayScript(1, "action", "MoveSprite(3, \"se\", false, true);");
SetMapDelayScript(MS+1, "action", "MoveSprite(3, \"se\", false, true);");
SetMapDelayScript(MS*2+1, "action", "MoveSprite(3, \"se\", false, true);");
SetMapDelayScript(MS*3+1, "action", "Sprite[3].advance = false;Sprite[3].direction = 7;Sprite[3].frame = 1;"); 

Sprite[4].cube = 113;
Sprite[4].advance = true;
Cube[113].sprite = 4;


SetMapDelayScript(1, "action", "MoveSprite(4, \"se\", false, true);");
SetMapDelayScript(MS+1, "action", "MoveSprite(4, \"se\", false, true);");
SetMapDelayScript(MS*2+1, "action", "MoveSprite(4, \"se\", false, true);");
SetMapDelayScript(MS*3+1, "action", "MoveSprite(4, \"se\", false, true);");
SetMapDelayScript(MS*4+1, "action", "MoveSprite(4, \"se\", false, true);");
SetMapDelayScript(MS*5+1, "action", "MoveSprite(4, \"se\", false, true);");
SetMapDelayScript(MS*5+1, "action", "Sprite[3].direction = 5;");
SetMapDelayScript(MS*6+1, "action", "MoveSprite(4, \"se\", false, true);");
SetMapDelayScript(MS*6+1, "action", "Sprite[4].advance = false;Sprite[4].direction = 7;Sprite[4].frame = 1;");
SetMapDelayScript(MS*7+1, "action", "CenterCameraTo(Cube[20].x+.5,Cube[20].y+.5,Cube[20].z +Cube[20].height);");
SetMapDelayScript(MS*8+1, "action", "CutScene1_5();");
}

function CutScene1_5()
{
//tempy2 = 0;
Foreground = true;
CurrentText = 40;
CurrentName = 2;
Port1 = LoadImage("Port2.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene1_6();\");";

//sub function used as a delay script in the map engine
}

function CutScene1_6()
{
Foreground = true;
CurrentText++;
CurrentName = 3;
Port1 = LoadImage("Port3.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene1_7();\");";
}

function CutScene1_7()
{
Foreground = true;
CurrentText++;
CurrentName = 2;
Port1 = LoadImage("Port2.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene1_8();\");";
}

function CutScene1_8()
{
Foreground = true;
CurrentText++;
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene1_9();\");";
}

function CutScene1_9()
{
Foreground = true;
CurrentText++;
CurrentName = 3;
Port1 = LoadImage("Port3.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene1_10();\");";
}

function CutScene1_10()
{
Foreground = true;
CurrentText++;
CurrentName = 2;
Port1 = LoadImage("Port2.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene1_11();\");";
}

function CutScene1_11()
{
Foreground = true;
CurrentText++;
CurrentName = 3;
Port1 = LoadImage("Port3.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene1_12();\");";
}

function CutScene1_12()
{
Foreground = true;
CurrentText++;
CurrentName = 2;
Port1 = LoadImage("Port2.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene1_13();\");";
}

function CutScene1_13()
{
Foreground = true;
CurrentText++;
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene1_14();\");";
}

function CutScene1_14()
{
Foreground = true;
CurrentText++;
CurrentName = 3;
Port1 = LoadImage("Port3.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene1_15();\");";
}

function CutScene1_15()
{
Foreground = false;
Sprite[4].advance = true;
Sprite[4].direction = 5;
Sprite[4].frame = 1;

//MoveSprite(4, "nw", false, false);
SetMapDelayScript(MS+1, "action", "Sprite[4].advance = true; Sprite[4].direction = 1;Sprite[4].frame = 2;");
SetMapDelayScript(MS+1, "action", "MoveSprite(4, \"nw\", false, true);");
SetMapDelayScript(MS*2+1, "action", "MoveSprite(4, \"nw\", false, true);");
SetMapDelayScript(MS*3+1, "action", "MoveSprite(4, \"nw\", false, true);");
SetMapDelayScript(MS*4+1, "action", "MoveSprite(4, \"nw\", false, true);");

	for (i=0; i<=MS*3; i++)
	{
	SetMapDelayScript(i+1+MS, "draw", "Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0," + Math.floor(i*255/(MS*3+1)) + "));"); 
	SetMapDelayScript(i+1+MS, "action", "SetScale("+(Scale-i*Scale/(MS*6))+");");
	}

SetMapDelayScript(MS*3+1, "action", "CutScene1_End();");
}
function CutScene1_End()
{
	for (i=0; i<100; i++)
	{
	DrawQueue[TheFrames+i] = undefined;
	ActionQueue[TheFrames+i] = undefined;
	}
ExitEngine();
}


function CutScene2()
{
LoadMap("b1-8");
Advancing = false;
Scale = .75;
RearrangeAngle();

LoadSpriteSetInfo(2, "demon");
LoadSpriteSetInfo(3, "behemoth");
LoadSpriteSetInfo(4, "elmdor");

//set sprites
Sprite[1].direction = 6; //The direction the sprite is physically facing on the screen.
Sprite[1].fdir = 2;//the direction the sprite is facing (with reference to direction "d1");
Sprite[1].frame = 1;
Sprite[1].spriteset = 4;
Sprite[1].xoff = 14;//SpriteSet[Sprite[1].spriteset][1][1].width/2;
Sprite[1].yoff = 20;//SpriteSet[Sprite[1].spriteset][1][1].height-20;
Sprite[1].yoff2 = 0;
Sprite[1].xadd = 0;
Sprite[1].yadd = 0;
Sprite[1].zadd = 0;
Sprite[1].cube = 4;
Sprite[1].advance = false;
Cube[4].sprite = 1;

Sprite[2].direction = 2; //The direction the sprite is physically facing on the screen.
Sprite[2].fdir = 2;//the direction the sprite is facing (with reference to direction "d1");
Sprite[2].frame = 3;
Sprite[2].spriteset = 3;
Sprite[2].xoff = SpriteSet[Sprite[2].spriteset][1][1].width/2+1;
Sprite[2].yoff = 30;
Sprite[2].yoff2 = 0;
Sprite[2].xadd = 0;
Sprite[2].yadd = 0;
Sprite[2].zadd = 0;
Sprite[2].cube = 49;
Cube[49].sprite = 2;

Cube[63].sprite = undefined;

//cube 4
Foreground = false;
StandardView();
CenterCameraCube(4);

SetMapDelayScript(1, "action", "CutScene2_FadeIn();");
NextFrame(false, false);
CutSceneMenu();
}

function CutScene2_FadeIn()
{
Scale = .75;
	for (i=0; i<60; i++)
	{
	SetMapDelayScript(i, "draw", "Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0," + (255 - Math.floor(i*255/60)) + "));");
	}
	SetMapDelayScript(60, "action", "CutScene2_1();");
}

function CutScene2_1()
{
Foreground = true;
CurrentText = 50;
CurrentName = 1;
Port1 = LoadImage("Port1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene2_2();\");";
//sub function used as a delay script in the map engine
}
function CutScene2_2()
{
Foreground = true;
CurrentText++;
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene2_3();\");";
}

function CutScene2_3()
{
Foreground = true;
CurrentText++;
DoneTextScript = "SetMapDelayScript(30, \"action\", \"CutScene2_4();\");";
}

function CutScene2_4()
{
Foreground = true;
CurrentText++;
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene2_5();\");";
}

function CutScene2_5()
{
Sprite[1].advance = true;
Sprite[1].direction = 2;
Sprite[1].frame = 3;
Foreground = false;

while(AreKeysLeft())
GetKey();

MoveSprite(1, "se", true);
MoveSprite(1, "sw", true);
MoveSprite(1, "se", true);
MoveSprite(1, "ne", true);
MoveSprite(1, "se", true);
MoveSprite(1, "se", true);
MoveSprite(1, "se", true);
MoveSprite(1, "ne", true);
MoveSprite(1, "ne", true);
MoveSprite(1, "se", true);
MoveSprite(1, "sw", true);

Sprite[1].direction = 5; 
Sprite[1].fdir = 1;
Sprite[1].frame = 1;
Sprite[1].advance = false;

SetMapDelayScript(20, "action", "CutScene2_6();");
}

function CutScene2_6()
{
Foreground = true;
CurrentText++;

DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene2_7();\");";
}

function CutScene2_7()
{
Foreground = true;
CurrentText++;
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene2_8();\");";
}

function CutScene2_8()
{
Foreground = true;
CurrentText++;
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene2_9();\");";
}

function CutScene2_9()
{
Foreground = true;
CurrentText++;
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene2_10();\");";
}

function CutScene2_10()
{
Sprite[1].advance = true;
Sprite[1].direction = 2;
Sprite[1].frame = 3;
Foreground = false;

MoveSprite(1, "sw", true);
MoveSprite(1, "sw", true);
MoveSprite(1, "sw", true);
MoveSprite(1, "se", true);
MoveSprite(1, "sw", true);
MoveSprite(1, "sw", true);

Sprite[1].direction = 5; 
Sprite[1].fdir = 1;
Sprite[1].frame = 1;
Sprite[1].advance = false;
Sprite[2].advance = true;
MoveSprite(2, "sw", false, true);

SetMapDelayScript(80, "action", "CutScene2_11();");
}

function CutScene2_11()
{
Foreground = true;
CurrentText++;
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene2_12();\");";
}

function CutScene2_12()
{
MoveSprite(2, "sw", false);
MoveSprite(2, "sw", false);

//Do these two with the map engine
MoveSprite(1, "sw", false, true);
MoveSprite(2, "sw", false, true);

	for (i=0; i<=MS*2; i++)
	{
	SetMapDelayScript(i, "draw", "Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0," + Math.floor(i*255/51) + "));"); 
	SetMapDelayScript(i, "action", "SetScale("+(Scale-i*Scale/(MS*4))+");");
	}

SetMapDelayScript(MS, "action", "CutScene2_13();");
}

function CutScene2_13()
{
Sprite[1].direction = 5; 
Sprite[1].fdir = 1;
Sprite[1].frame = 1;
Sprite[1].advance = false;

MoveSprite(2, "sw", false,true);

SetMapDelayScript(MS, "action", "CutScene2_End();");
}

function CutScene2_End()
{
ExitEngine();
}

function CutScene3()
{
LoadMap("Cave4");
Advancing = false;
//set up forground function.
Scale = .75;
x_angle = .75;
y_angle = -.75;
RearrangeAngle();

LoadSpriteSetInfo(2, "bull");
LoadSpriteSetInfo(3, "behemoth");
LoadSpriteSetInfo(4, "demon");
LoadSpriteSetInfo(5, "male2");

SetSpriteSet(1, 2);
Sprite[1].direction = 2; 
Sprite[1].fdir = 2;
Sprite[1].frame = 3;
Sprite[1].advance = false;
//Sprite[1].spriteset = 2;
Sprite[1].cube = 7;
Sprite[1].yoff += 2;
Cube[7].sprite = 1;

SetSpriteSet(2, 2);
Sprite[2].direction = 2; 
Sprite[2].fdir = 2;
Sprite[2].frame = 3;
Sprite[2].advance = false;
//Sprite[2].spriteset = 2;
Sprite[2].cube = 3;
Sprite[2].yoff += 2;
Cube[3].sprite = 2;

SetSpriteSet(3, 4);
Sprite[3].direction = 6; 
Sprite[3].fdir = 2;
Sprite[3].frame = 1;
Sprite[3].advance = false;
Sprite[3].cube = 6;
Sprite[3].yoff2 = 0;
Cube[6].sprite = 3;

SetSpriteSet(4, 5);
Sprite[4].direction = 6; 
Sprite[4].fdir = 2;
Sprite[4].frame = 1;
Sprite[4].advance = false;
Sprite[4].cube = 73;
Sprite[4].yoff2 = 0;
//Cube[73].sprite = 4;

//cube 4
Foreground = false;
StandardView();
CenterCameraCube(13);

SetMapDelayScript(1, "action", "CutScene3_FadeIn();");
NextFrame(false, false);
CutSceneMenu();
}

function CutScene3_FadeIn()
{
Scale = .75;
	for (i=0; i<60; i++)
	{
	SetMapDelayScript(i, "draw", "Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0," + (255 - Math.floor(i*255/60)) + "));");
	}
	SetMapDelayScript(110, "action", "CutScene3_1();");
}

function CutScene3_1()
{
	for (i=0; i<75; i++)
	{
	SetMapDelayScript(i, "action", "x_angle -= 0.005;y_angle+=0.005; RearrangeAngle();");
	}
	SetMapDelayScript(100, "action", "CutScene3_2();");
}

function CutScene3_2()
{
Cube[73].sprite = 4;
Sprite[4].advance = true;
MoveSprite(4, "nw", false);
MoveSprite(4, "nw", false);
MoveSprite(4, "ne", false);
MoveSprite(4, "ne", false);
MoveSprite(4, "ne", false);
MoveSprite(4, "nw", false);
MoveSprite(4, "nw", false);
Sprite[4].advance = false;
Sprite[4].frame = 3;
SetMapDelayScript(30, "action", "CutScene3_3();");
}

function CutScene3_3()
{
//0
Foreground = true;
CurrentText= 20;
CurrentName = 4;
Port1 = LoadImage("Port5.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_4();\");";
}

function CutScene3_4()
{
//1
Foreground = true;
CurrentText++;
CurrentName = 5;
Port1 = LoadImage("Port6.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_5();\");";
}

function CutScene3_5()
{
//2
Foreground = true;
CurrentText++;
CurrentName = 4;
Port1 = LoadImage("Port5.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_6();\");";
}

function CutScene3_6()
{
//3
Foreground = true;
CurrentText++;
CurrentName = 5;
Port1 = LoadImage("Port6.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_7();\");";
}

function CutScene3_7()
{
//4
Foreground = true;
CurrentText++;
CurrentName = 4;
Port1 = LoadImage("Port5.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_8();\");";
}

function CutScene3_8()
{
//5
Foreground = true;
CurrentText++;
CurrentName = 5;
Port1 = LoadImage("Port6.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_9();\");";
}

function CutScene3_9()
{
//6
Foreground = true;
CurrentText++;
CurrentName = 4;
Port1 = LoadImage("Port5.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene3_10();\");";
}

function CutScene3_10()
{
//7
Foreground = true;
CurrentText++;
CurrentName = 4;
Port1 = LoadImage("Port5.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_11();\");";
}


function CutScene3_11()
{
//8
Foreground = true;
CurrentText++;
CurrentName = 5;
Port1 = LoadImage("Port6.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_12();\");";
}

function CutScene3_12()
{
//9
Foreground = true;
CurrentText++;
CurrentName = 4;
Port1 = LoadImage("Port5.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene3_13();\");";
}
function CutScene3_13()
{
//10
Foreground = true;
CurrentText++;
CurrentName = 4;
Port1 = LoadImage("Port5.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_14();\");";
}
function CutScene3_14()
{
//11
Foreground = true;
CurrentText++;
CurrentName = 5;
Port1 = LoadImage("Port6.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_15();\");";
}
function CutScene3_15()
{
//12
Foreground = true;
CurrentText++;
CurrentName = 4;
Port1 = LoadImage("Port5.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_16();\");";
}
function CutScene3_16()
{
//13
Foreground = true;
CurrentText++;
CurrentName = 5;
Port1 = LoadImage("Port6.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_17();\");";
}
function CutScene3_17()
{
//14
Foreground = true;
CurrentText++;
CurrentName = 4;
Port1 = LoadImage("Port5.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene3_18();\");";
}
function CutScene3_18()
{
//15
Foreground = true;
CurrentText++;
CurrentName = 4;
Port1 = LoadImage("Port5.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_19();\");";
}
function CutScene3_19()
{
//16
Foreground = true;
CurrentText++;
CurrentName = 5;
Port1 = LoadImage("Port6.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene3_20();\");";
}
function CutScene3_20()
{
//17
Foreground = true;
CurrentText++;
CurrentName = 5;
Port1 = LoadImage("Port6.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_21();\");";
}
function CutScene3_21()
{
//18
Foreground = true;
CurrentText++;
CurrentName = 4;
Port1 = LoadImage("Port5.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene3_22();\");";
}
function CutScene3_22()
{
Sprite[4].advance = true;
MoveSprite(4, "se", false);
MoveSprite(4, "se", false);
MoveSprite(4, "sw", false,true);
SetMapDelayScript(26, "action", 'MoveSprite(4, "sw", false,true);');
SetMapDelayScript(52, "action", 'MoveSprite(4, "sw", false,true);');

	for (i=0; i<=76; i++)
	{
	SetMapDelayScript(i, "draw", "Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0," + Math.floor(i*255/76) + ")); SetScale("+(Scale-i*Scale/150)+")");
	}

SetMapDelayScript(76, "action", "CutScene3_End();");
}

function CutScene3_End()
{
ExitEngine();
}

function CutScene4()
{
LoadMap("Castle3s");
Advancing = false;
//set up forground function.
Scale = 1.5;//.25;
x_angle = .75;
y_angle = -.75;
RearrangeAngle();

ResetSprites();
LoadSpriteSetInfo(2, "test2_2");
LoadSpriteSetInfo(3, "behemoth");
LoadSpriteSetInfo(4, "demon");
LoadSpriteSetInfo(5, "test8");

Sprite[0].advance = false;

SetSpriteSet(1, 2);
Sprite[1].direction = 2; 
Sprite[1].fdir = 2;
Sprite[1].frame = 3;
Sprite[1].advance = true;
//Sprite[1].spriteset = 2;
Sprite[1].cube = 56;
Sprite[1].yoff += 2;
Cube[56].sprite = 1;

SetSpriteSet(2, 5);
Sprite[2].direction = 2; 
Sprite[2].fdir = 2;
Sprite[2].frame = 3;
Sprite[2].advance = true;
//Sprite[2].spriteset = 2;
Sprite[2].cube = 31;
Sprite[2].yoff += 2;
Cube[31].sprite = 2;

/*SetSpriteSet(3, 4);
Sprite[3].direction = 6; 
Sprite[3].fdir = 2;
Sprite[3].frame = 1;
Sprite[3].advance = false;
Sprite[3].cube = 6;
Sprite[3].yoff2 = 0;
Cube[6].sprite = 3;

SetSpriteSet(4, 5);
Sprite[4].direction = 6; 
Sprite[4].fdir = 2;
Sprite[4].frame = 1;
Sprite[4].advance = false;
Sprite[4].cube = 73;
Sprite[4].yoff2 = 0;
//Cube[73].sprite = 4;
*/
Foreground = false;
StandardView();
CenterCameraCube(0);
SetScale(1.33);
//Scale = .75;
//x_angle = 0;
//y_angle = -3.14159/2;
RearrangeAngle();

SetMapDelayScript(120, "action", "CutScene4_Move1();");
//NextFrame(false, false);
EngineMenu();

CutSceneMenu();
}

function CutScene4_Move1()
{
//	SetupPaths(Cube[0].x,Cube[0].y,Cube[0].z, 7);
//	GoToCube(Cube[19].x,Cube[19].y,Cube[19].z, 1, 7);
//	ClearCubes();
	var thingy = Math.floor(Math.random()*CubeNumber);

	if (Cube[thingy].pic1 >= 0)
	{
		SetupPaths(Cube[Sprite[1].cube].x,Cube[Sprite[1].cube].y,Cube[Sprite[1].cube].z, 54);
		GoToCube(Cube[thingy].x, Cube[thingy].y, Cube[thingy].z, 1, 32);
		ClearCubes();
	}

	if (Cube[thingy].sprite == 1)
	{
	SetMapDelayScript(60, "action", "CutScene4_Move1();");
	}
	else
	{
	SetMapDelayScript(1, "action", "CutScene4_Move1();");
	}
}

function CutScene4_Move1()
{

}
/*
function CutScene4_Move1()
{
	while(!IsKeyPressed(KEY_ESCAPE))
	{
	ZoneMove(1, Math.floor(Math.random()*64));
		for (tempi=0; tempi<50; tempi++)
		{
		DrawMap();
		FlipScreen();
		Frames++;
		TheFrames++;
		}
	}
SetMapDelayScript(100, "action", "ExitEngine();");
}
*/
/*
function CutScene4()
{
CDir = "d1";
DrawModel(0,2,2,-2);
FlipScreen();
GetKey();
}
*/
/*
function CutScene4()
{
//Used to test the speed of bliting
var image1 = LoadImage("6.png");
var image2 = LoadImage("16.png");

	while(IsKeyPressed(KEY_SPACE) == false)
	{
		for (i=0; i<123; i++)
		{
		image1.transformBlit(0,0,64,0,64,64,0,64);
		}
	FlipScreen();
	}

	while(IsKeyPressed(KEY_ENTER) == false)
	{
		for (i=0; i<492; i++)
		{
		image2.transformBlit(0,0,32,0,32,32,0,32);
		}
	FlipScreen();
	}

NewCompile("Castle3");

}
*/

/*
function CutScene4()
{
LoadMap("Town7");
Advancing = false;
//set up forground function.
Scale = .75;

	for (c4i = 0; c4i<MaxCubes; c4i++)
	{
		if (Cube[c4i].z <= 22)
		{
		Cube[c4i].z/=2;
		Cube[c4i].height/=2;
		Cube[c4i].t1/=2;
		Cube[c4i].t2/=2;
		Cube[c4i].t3/=2;
		Cube[c4i].t4/=2;
		}
	}
GetPxyz();

LoadSpriteSetInfo(2, "male1");
LoadSpriteSetInfo(3, "female1");
LoadSpriteSetInfo(4, "demon");
LoadSpriteSetInfo(5, "male2");

SetSpriteSet(1, 2);
Sprite[1].direction = 2; 
Sprite[1].fdir = 2;
Sprite[1].frame = 3;
Sprite[1].advance = false;
//Sprite[1].spriteset = 2;
Sprite[1].cube = 17;
//Cube[7].sprite = 17;

SetSpriteSet(2, 3);
Sprite[2].direction = 2; 
Sprite[2].fdir = 2;
Sprite[2].frame = 3;
Sprite[2].advance = false;
//Sprite[2].spriteset = 2;
Sprite[2].cube = 74;

Cube[74].sprite = -1;

//SetSpriteSet(3, 4);
//Sprite[3].direction = 6; 
//Sprite[3].fdir = 2;
//Sprite[3].frame = 1;
//Sprite[3].advance = false;
//Sprite[3].cube = 6;
//Sprite[3].yoff2 = 0;
//Cube[6].sprite = 3;


//SetSpriteSet(4, 5);
//Sprite[4].direction = 6; 
//Sprite[4].fdir = 2;
//Sprite[4].frame = 1;
//Sprite[4].advance = false;
//Sprite[4].cube = 73;
//Sprite[4].yoff2 = 0;
////Cube[73].sprite = 4;

//cube 4
Foreground = false;
StandardView();
//x_angle = 3*3.14159/4;
//y_angle = 3.14159/4;
//RearrangeAngle();

CenterCameraCube(17);

SetMapDelayScript(0, "action", "CutScene4_FadeIn();");
NextFrame(false, false);
CutSceneMenu();
}

function CutScene4_FadeIn()
{
Scale = .75;
	for (i=0; i<60; i++)
	{
	SetMapDelayScript(i, "draw", "Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0," + (255 - Math.floor(i*255/60)) + "));");
	}
	SetMapDelayScript(110, "action", "CutScene4_1();");
}

function CutScene4_1()
{
RotateCamera(3.14159/2, false, true, Cube[17].x+.5, Cube[17].y+.5, Cube[17].z + Cube[17].height, 50);
//80
//81
Cube[80].pic3 = 22;
Cube[81].pic3 = 21;

//80
//81
//CDir="d2";
RearrangeAngle();

SetMapDelayScript(30, "action", "Cube[17].sprite = 1; Sprite[1].advance = true;");
SetMapDelayScript(60, "action", "Cube[80].pic3 = 10;Cube[81].pic3 = 9;CutScene4_2();");
//17
//56

//SetMapDelayScript(70, "action", "CenterCameraToV2(Cube[17].x+.5,Cube[17].y+.5,Cube[17].z+Cube[17].height,Cube[56].x+.5,Cube[56].y+.5,Cube[56].z+Cube[56].height, true, 2, -3.14159/2);");
}

function CutScene4_2()
{
MoveSprite(1, 'se', true,false);
MoveSprite(1, 'se', true,false);
MoveSprite(1, 'sw', true,false);
MoveSprite(1, 'sw', true,false);
Cube[74].sprite = 2;
MoveSprite(1, 'sw', true,false);
MoveSprite(1, 'sw', true,false);
MoveSprite(1, 'sw', true,false);
MoveSprite(1, 'sw', true,false);

Sprite[1].advance = false;
Sprite[1].direction = 8;
Sprite[1].frame = 1;

RotateCamera(-3.14159/2, false, true, Cube[56].x+.5, Cube[56].y+.5, Cube[56].z + Cube[56].height, 25);
SetMapDelayScript(60, "action", "CutScene4_3();");
//SetMapDelayScript(10, "action", "MoveSprite(1, 'se', true,false);MoveSprite(1, 'se', true,false);MoveSprite(1, 'se', true,false);");
//MoveSprite(1, 'se', true,true);
//MoveSprite(1, 'se', true,true);
}

function CutScene4_3()
{
Foreground = true;
CurrentText= 0;
CurrentName = 6;
Port1 = LoadImage("Port8.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene4_4();\");";
}

function CutScene4_4()
{
Foreground = true;
CurrentText++;
CurrentName = 7;
Port1 = LoadImage("Port7.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene4_5();\");";
}

function CutScene4_5()
{
Foreground = true;
CurrentText++;
CurrentName = 6;
Port1 = LoadImage("Port8.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene4_6();\");";
}

function CutScene4_6()
{
Foreground = true;
CurrentText++;
CurrentName = 7;
Port1 = LoadImage("Port7.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene4_7();\");";
}

function CutScene4_7()
{
Foreground = true;
CurrentText++;
CurrentName = 6;
Port1 = LoadImage("Port8.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene4_8();\");";
}

function CutScene4_8()
{
Foreground = true;
CurrentText++;
CurrentName = 7;
Port1 = LoadImage("Port7.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene4_9();\");";
}

function CutScene4_9()
{
Foreground = true;
CurrentText++;
CurrentName = 6;
Port1 = LoadImage("Port8.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene4_10();\");";
}

function CutScene4_10()
{
Foreground = true;
CurrentText++;
CurrentName = 7;
Port1 = LoadImage("Port7.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene4_11();\");";
}

function CutScene4_11()
{
Foreground = true;
CurrentText++;
CurrentName = 6;
Port1 = LoadImage("Port8.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene4_12();\");";
}

function CutScene4_12()
{
Foreground = true;
CurrentText++;
CurrentName = 7;
Port1 = LoadImage("Port7.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene4_13();\");";
}

function CutScene4_13()
{
Foreground = true;
CurrentText++;
CurrentName = 6;
Port1 = LoadImage("Port8.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene4_14();\");";
}

function CutScene4_14()
{
Foreground = true;
CurrentText++;
CurrentName = 7;
Port1 = LoadImage("Port7.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene4_15();\");";
}

function CutScene4_15()
{
Foreground = true;
CurrentText++;
CurrentName = 7;
Port1 = LoadImage("Port7.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene4_16();\");";
}

function CutScene4_16()
{
Foreground = true;
CurrentText++;
CurrentName = 6;
Port1 = LoadImage("Port8.png");
DoneTextScript = "SetMapDelayScript(10, \"action\", \"CutScene4_17();\");";
}

function CutScene4_17()
{

}
*/

function CutScene5()
{
LoadMap("Room1");
Advancing = false;
StandardView();
SetScale(.25);
x_angle -= 2*3.14159;
y_angle -= 2*3.14159;
TiltAmount = .66;
RearrangeAngle();
LoadSpriteSetInfo(1, "test");
LoadSpriteSetInfo(2, "test6");
LoadSpriteSetInfo(3, "test4");
LoadSpriteSetInfo(4, "decal1");
Cube[11].sprite = 4;
Cube[34].sprite = -1;
Sprite[4].spriteset =4;
Sprite[4].direction = 1;
Sprite[4].fdir = 1;
Sprite[4].frame = 1;
Sprite[4].xoff = 14;
Sprite[4].yoff = 20;
Sprite[4].yoff2 = 0;
Sprite[4].xadd = 0;
Sprite[4].yadd = 0;
Sprite[4].zadd = 0;
Sprite[4].cube = 11;
Sprite[4].advance = false;


//36 nw
//32 nw
//28 ne

//set sprites
Sprite[1].direction = 13; //The direction the sprite is physically facing on the screen.
Sprite[1].fdir = 3;//the direction the sprite is facing (with reference to direction "d1");
Sprite[1].frame = 1;
Sprite[1].spriteset = 1;
Sprite[1].xoff = 14;//SpriteSet[Sprite[1].spriteset][1][1].width/2;
Sprite[1].yoff = 20;//SpriteSet[Sprite[1].spriteset][1][1].height-20;
Sprite[1].yoff2 = 0;
Sprite[1].xadd = 0;
Sprite[1].yadd = 0;
Sprite[1].zadd = 0;
Sprite[1].cube = 31;
Sprite[1].advance = false;
Cube[31].sprite = 1;

Sprite[2].direction = 8; //The direction the sprite is physically facing on the screen.
Sprite[2].fdir = 4;//the direction the sprite is facing (with reference to direction "d1");
Sprite[2].frame = 1;
Sprite[2].spriteset = 2;
Sprite[2].xoff = 14;//SpriteSet[Sprite[1].spriteset][1][1].width/2;
Sprite[2].yoff = 20;//SpriteSet[Sprite[1].spriteset][1][1].height-20;
Sprite[2].yoff2 = 0;
Sprite[2].xadd = 0;
Sprite[2].yadd = 0;
Sprite[2].zadd = 0;
Sprite[2].cube = 26;
Sprite[2].advance = false;
Cube[32].sprite = -1;//2
SetScale(0.95);
Foreground = false;
//StandardView();
CenterCamera(-1.5,1,1);

SetMapDelayScript(1, "action", "CutScene5_FadeIn();");
NextFrame(false, false);
CutSceneMenu();
}

function CutScene5_FadeIn()
{
	for (i=0; i<60; i++)
	{
	SetMapDelayScript(i, "draw", "Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0," + (255 - Math.floor(i*255/60)) + "));");
	}
	SetMapDelayScript(110, "action", "CutScene5_1();");
}

function CutScene5_1()
{
//58//10
//57//9
//pic3

Cube[58].pic3 = 25;
Cube[57].pic3 = 21;
//78
//77
SetMapDelayScript(20, "action", "Sprite[2].direction = 2; Sprite[2].fdir = 2; Sprite[2].frame = 3;Sprite[2].spriteset = 2;Sprite[2].xoff = 14;Sprite[2].yoff = 20;Sprite[2].cube = 26;Cube[26].sprite = 2;Sprite[2].advance = false;");
SetMapDelayScript(20+MS+1, "action", "Sprite[2].advance = true;MoveSprite(2, 'se', false,true);");
SetMapDelayScript(20+2*MS+1, "action", "MoveSprite(2, 'se', false,true);");
SetMapDelayScript(40, "action", "Cube[58].pic3 = 10; Cube[57].pic3 = 9;");
SetMapDelayScript(20+3*MS+1, "action", "MoveSprite(2, 'se', false,true);");
SetMapDelayScript(20+4*MS+1, "action", "Sprite[2].advance = false; Sprite[2].frame = 3;");
SetMapDelayScript(110, "action", "Sprite[1].frame++;");
SetMapDelayScript(125, "action", "Sprite[1].frame++;");
SetMapDelayScript(155, "action", "CutScene5_2();");
}

function CutScene5_2()
{
Foreground = true;
CurrentText = 60;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_3();\");";
}
function CutScene5_3()
{
Foreground = true;
CurrentText++;
CurrentName = 2;
Port1 = LoadImage("Port_2.png");
DoneTextScript = "SetMapDelayScript(101, \"action\", \"CutScene5_4();\");SetMapDelayScript(1, 'action', 'Sprite[1].frame++;');SetMapDelayScript(16, 'action', 'Sprite[1].frame++;');SetMapDelayScript(31, 'action', 'Sprite[1].frame++;');SetMapDelayScript(51, 'action', 'Sprite[1].direction = 3;Sprite[1].frame=3;');SetMapDelayScript(71, 'action', 'Sprite[1].direction = 4;');";
}

function CutScene5_4()
{
Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_5();\");";
}

function CutScene5_5()
{
Foreground = true;
CurrentText++;
CurrentName = 2;
Port1 = LoadImage("Port_2.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_6();\");";
}

function CutScene5_6()
{
Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_7();\");";
}

function CutScene5_7()
{
Foreground = true;
CurrentText++;
CurrentName = 2;
Port1 = LoadImage("Port_2.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_7b();\");";
}

function CutScene5_7b()
{
Foreground = true;
CurrentText++;
CurrentName = 2;
Port1 = LoadImage("Port_2.png");
DoneTextScript = "SetMapDelayScript(21, \"action\", \"Sprite[2].advance = true;MoveSprite(2, 'nw', false, false);Sprite[2].advance = false;Sprite[2].frame = 3;SetMapDelayScript(41, \'action\', \'CutScene5_7c();\');\");";
}

function CutScene5_7c()
{
Foreground = true;
CurrentText++;
CurrentName = 2;
Port1 = LoadImage("Port_2.png");
DoneTextScript = "SetMapDelayScript(21, \"action\", \"CutScene5_8();\");";
}

function CutScene5_8()
{
Sprite[2].advance = true;

MoveSprite(2, 'nw', false, false);
MoveSprite(2, 'nw', false, false);
Sprite[2].advance = false; 
Sprite[2].frame = 3;
SetMapDelayScript(20, 'action','Cube[58].pic3 = 25;Cube[57].pic3 = 21;');
SetMapDelayScript(40, 'action','Sprite[2].cube = -1; Cube[26].sprite = -1;');
SetMapDelayScript(60, 'action','Cube[58].pic3 = 10;Cube[57].pic3 = 9; Sprite[1].direction = 3');
SetMapDelayScript(100, 'action','Cube[58].pic3 = 25;Cube[57].pic3 = 21;');
SetMapDelayScript(120, 'action','Sprite[3].direction = 2; Sprite[3].fdir = 2; Sprite[3].frame = 3;Sprite[3].spriteset = 3;Sprite[3].xoff = 14;Sprite[3].yoff = 20;Sprite[3].yoff2 = 1;Sprite[3].cube = 26;Cube[26].sprite = 3;Sprite[3].advance = false;');
SetMapDelayScript(140, 'action','Cube[58].pic3 = 10;Cube[57].pic3 = 9;         Sprite[3].advance = true;MoveSprite(3, "se", false, false);MoveSprite(3, "se", false, false);MoveSprite(3, "se", false, true);');
SetMapDelayScript(140+MS+1, 'action', 'MoveSprite(3, "se", false, true);');
//SetMapDelayScript(140+2*MS+1, 'action', 'MoveSprite(3, "se", false, true);');
SetMapDelayScript(140+2*MS+1, 'action','Sprite[3].advance = false; Sprite[3].frame = 3;');
SetMapDelayScript(140+2*MS+8, 'action','Sprite[3].direction = 2;');
//SetMapDelayScript(140+Math.floor(2.5*MS)+1, 'action','Sprite[1].direction = 1;');
SetMapDelayScript(150, 'action','Sprite[1].direction = 4;');
SetMapDelayScript(150+MS+1, 'action','CutScene5_9();');
}

function CutScene5_9()
{
Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_10();\");";
}

function CutScene5_10()
{
Foreground = true;
CurrentText++;
CurrentName = 3;
Port1 = LoadImage("Port_3.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_11();\");";
}

function CutScene5_11()
{
Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_12();\");";
}

function CutScene5_12()
{
Foreground = true;
CurrentText++;
CurrentName = 3;
Port1 = LoadImage("Port_3.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_13();\");";
}

function CutScene5_13()
{
Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_14();\");";
}

function CutScene5_14()
{
Foreground = true;
CurrentText++;
CurrentName = 3;
Port1 = LoadImage("Port_3.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_15();\");";
}

function CutScene5_15()
{
Foreground = true;
CurrentText++;
CurrentName = 3;
Port1 = LoadImage("Port_3.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_16();\");";
}
function CutScene5_16()
{
Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_17();\");";
}

function CutScene5_17()
{
Foreground = true;
CurrentText++;
CurrentName = 3;
Port1 = LoadImage("Port_3.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_18();\");";
}

function CutScene5_18()
{
Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_19();\");";
}

function CutScene5_19()
{
Foreground = true;
CurrentText++;
CurrentName = 3;
Port1 = LoadImage("Port_3.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_20();\");";
}

function CutScene5_20()
{
Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_21();\");";
}

function CutScene5_21()
{
Foreground = true;
CurrentText++;
CurrentName = 3;
Port1 = LoadImage("Port_3.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene5_22();\");";
}

function CutScene5_22()
{
Sprite[3].advance = true;
MoveSprite(3, "nw", false, false);
Sprite[1].advance = true;
MoveSprite(3, "nw", false, true);
MoveSprite(1, "nw", false, true);
SetMapDelayScript(MS+1, "action", "MoveSprite(3, 'nw', false, true);MoveSprite(1, 'nw', false, true);");
SetMapDelayScript(2*MS+1, "action", "MoveSprite(3, 'nw', false, true);MoveSprite(1, 'nw', false, true);");
//SetMapDelayScript(3*MS+1, "action", "MoveSprite(3, 'nw', false, true);MoveSprite(1, 'nw', false, true);");
SetMapDelayScript(3*MS+1, "action", "Sprite[3].advance = false; Sprite[3].frame = 3;MoveSprite(1, 'nw', false, true);");
//SetMapDelayScript(3*MS+8, "action", "Cube[58].pic3 = 25;Cube[57].pic3 = 21;");
	for (i=0; i<=2.5*MS; i++)
	{
	SetMapDelayScript(MS+i+1, "draw", "Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0," + Math.floor(i*255/(2.5*MS)) + ")); SetScale("+(Scale-i*Scale/250)+")");
	}

SetMapDelayScript(Math.floor(3.5*MS)+1, "action", "ExitEngine();");
}



function CutScene6()
{
LoadMap("Castle3s");
Advancing = false;
StandardView();
SetScale(.25);
x_angle = -.51461;
y_angle = -2.08539;
TiltAmount = .06;
RearrangeAngle();
LoadSpriteSetInfo(1, "test");
LoadSpriteSetInfo(2, "test5");
LoadSpriteSetInfo(3, "test8_2");
LoadSpriteSetInfo(4, "test2_2");
Cube[31].sprite = -1;

//set sprites
Sprite[4].direction = 1; //The direction the sprite is physically facing on the screen.
Sprite[4].fdir = 4;//the direction the sprite is facing (with reference to direction "d1");
Sprite[4].frame = 3;
Sprite[4].spriteset = 4;
Sprite[4].xoff = 14;//SpriteSet[Sprite[1].spriteset][1][1].width/2;
Sprite[4].yoff = 20;//SpriteSet[Sprite[1].spriteset][1][1].height-20;
Sprite[4].yoff2 = 0;
Sprite[4].xadd = 0;
Sprite[4].yadd = 0;
Sprite[4].zadd = 0;
Sprite[4].cube = 36;
Sprite[4].advance = false;
Cube[36].sprite = 4;

Sprite[5].direction = 4;
Sprite[5].fdir = 4;
Sprite[5].frame = 3;
Sprite[5].spriteset = 4;
Sprite[5].xoff = 14;
Sprite[5].yoff = 20;
Sprite[5].yoff2 = 0;
Sprite[5].xadd = 0;
Sprite[5].yadd = 0;
Sprite[5].zadd = 0;
Sprite[5].cube = 32;
Sprite[5].advance = false;
Cube[32].sprite = 5;

Sprite[6].direction = 4;
Sprite[6].fdir = 3;
Sprite[6].frame = 3;
Sprite[6].spriteset = 4;
Sprite[6].xoff = 14;
Sprite[6].yoff = 20;
Sprite[6].yoff2 = 0;
Sprite[6].xadd = 0;
Sprite[6].yadd = 0;
Sprite[6].zadd = 0;
Sprite[6].cube = 28;
Sprite[6].advance = false;
Cube[28].sprite = 6;


//36 nw
//32 nw
//28 ne

//set sprites
Sprite[1].direction = 4;
Sprite[1].fdir = 3;
Sprite[1].frame = 3;
Sprite[1].spriteset = 1;
Sprite[1].xoff = 14;
Sprite[1].yoff = 20;
Sprite[1].yoff2 = 0;
Sprite[1].xadd = 0;
Sprite[1].yadd = 0;
Sprite[1].zadd = 0;
Sprite[1].cube = 102;
Sprite[1].advance = false;
Cube[102].sprite = -1;

Sprite[2].direction = 2;
Sprite[2].fdir = 1;
Sprite[2].frame = 3;
Sprite[2].spriteset = 2;
Sprite[2].xoff = 14;
Sprite[2].yoff = 20;
Sprite[2].yoff2 = 0;
Sprite[2].xadd = 0;
Sprite[2].yadd = 0;
Sprite[2].zadd = 0;
Sprite[2].cube = 15;
Sprite[2].advance = false;
Cube[15].sprite = 2;

Sprite[3].direction = 4;
Sprite[3].fdir = 3;
Sprite[3].frame = 3;
Sprite[3].spriteset = 3;
Sprite[3].xoff = 14;
Sprite[3].yoff = 20;
Sprite[3].yoff2 = 0;
Sprite[3].xadd = 0;
Sprite[3].yadd = 0;
Sprite[3].zadd = 0;
Sprite[3].cube = 23;
Sprite[3].advance = false;
Cube[23].sprite = 3;

SetScale(0.25);
Foreground = false;
//StandardView();
CenterCamera(-3, -4, -2);

SetMapDelayScript(1, "action", "CutScene6_FadeIn();");
NextFrame(false, false);
CutSceneMenu();
}

function CutScene6_FadeIn()
{
	for (i=0; i<100; i++)
	{
	SetMapDelayScript(i, "draw", "Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0," + (255 - Math.floor(i*255/100)) + "));	SetScale("+(.25+75*i/10000)+");TiltAmount = "+ (0.06 +6*i/1000) +"; RearrangeAngle();");
	}
	SetMapDelayScript(101, "action", "TileAmount = .66;SetScale(1);RearrangeAngle();");
	SetMapDelayScript(151, "action", "CutScene6_1();");
}

function CutScene6_1()
{
Cube[102].sprite = 1;
Sprite[1].advance = true;
MoveSprite(1, 'ne', false, false);
MoveSprite(1, 'ne', false, false);
MoveSprite(1, 'nw', false, false);
Sprite[2].direction = 3;
Sprite[2].fdir = 2;
MoveSprite(1, 'nw', false, false);
Sprite[3].direction = 3;
Sprite[3].fdir = 2;
MoveSprite(1, 'nw', false, true);
SetMapDelayScript(MS+1, "action", "Sprite[1].advance = false; Sprite[1].frame = 3;");
/*
}

function CutScene6_2()
{*/
Foreground = true;
CurrentText = 82;
CurrentName = 5;
Port1 = LoadImage("Port_5.png");
//DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_3();\");";
DoneTextScript = "CutScene6_3();";
}

function CutScene6_3()
{
Foreground = true;
CurrentText++;
CurrentName = 5;
Port1 = LoadImage("Port_5.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_4();\");";
}

function CutScene6_4()
{
Foreground = true;
CurrentText++;
CurrentName = 6;
Port1 = LoadImage("Port_6.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_5();\");";
}

function CutScene6_5()
{
Foreground = true;
CurrentText++;
CurrentName = 5;
Port1 = LoadImage("Port_5.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_5b();\");";
}

function CutScene6_5b()
{
Foreground = true;
CurrentText++;
CurrentName = 5;
Port1 = LoadImage("Port_5.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_6();\");";
}

function CutScene6_6()
{
Sprite[6].advance = true;
MoveSprite(6, "se", false, true);
SetMapDelayScript(MS+1, "action", "MoveSprite(6, 'se', false, true);");
SetMapDelayScript(2*MS+1, "action", "MoveSprite(6, 'sw', false, true);");
SetMapDelayScript(3*MS+1, "action", "MoveSprite(6, 'sw', false, true);");
SetMapDelayScript(4*MS+1, "action", "MoveSprite(6, 'sw', false, true);");
SetMapDelayScript(5*MS+1, "action", "MoveSprite(6, 'sw', false, true);");
SetMapDelayScript(6*MS+1, "action", "MoveSprite(6, 'sw', false, true);");
SetMapDelayScript(7*MS+1, "action", "MoveSprite(6, 'sw', false, true);");
SetMapDelayScript(8*MS+1, "action", "MoveSprite(6, 'sw', false, true);");
SetMapDelayScript(9*MS+1, "action", "Sprite[6].advance = false; Cube[Sprite[6].cube].sprite = -1; Sprite[6].cube = -1;");

Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_7();\");";
}

function CutScene6_7()
{
Foreground = true;
CurrentText++;
CurrentName = 5;
Port1 = LoadImage("Port_5.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_8();\");";
}

function CutScene6_8()
{
Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_9();\");";
}

function CutScene6_9()
{
Foreground = true;
CurrentText++;
CurrentName = 5;
Port1 = LoadImage("Port_5.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_10();\");";
}

function CutScene6_10()
{
Sprite[2].advance = true;
MoveSprite(2, "nw", false, true);
WaitFrames(MS);
Sprite[3].direction = 4;
MoveSprite(2, "sw", false, true);
WaitFrames(MS);
Sprite[3].direction = 1;
MoveSprite(2, "nw", false, true);
WaitFrames(MS);
MoveSprite(2, "nw", false, true);
WaitFrames(MS);
MoveSprite(2, "nw", false, true);
WaitFrames(MS);
Cube[Sprite[2].cube].sprite = -1;
Sprite[2].cube = -1;

SetMapDelayScript(30, "action", "Sprite[3].direction = 1; CutScene6_11();");
SetMapDelayScript(40, "action", "Sprite[3].direction = 4;");
SetMapDelayScript(50, "action", "Sprite[3].direction = 3;");
}

function CutScene6_11()
{
Foreground = true;
CurrentText++;
CurrentName = 6;
Port1 = LoadImage("Port_6.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_12();\");";
}

function CutScene6_12()
{
Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_13();\");";
}

function CutScene6_13()
{
Foreground = true;
CurrentText++;
CurrentName = 6;
Port1 = LoadImage("Port_6.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_14();\");";
}

function CutScene6_14()
{
Foreground = true;
CurrentText++;
CurrentName = 6;
Port1 = LoadImage("Port_6.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_15();\");";
}

function CutScene6_15()
{
Sprite[1].direction = 14;
Sprite[1].frame = 1;
WaitFrames(15);
Sprite[1].direction = 14;
Sprite[1].frame = 2;
WaitFrames(15);

Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_16();\");";
}

function CutScene6_16()
{
Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_17();\");";
}

function CutScene6_17()
{
Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_18();\");";
}

function CutScene6_18()
{
Foreground = true;
CurrentText++;
CurrentName = 6;
Port1 = LoadImage("Port_6.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_19();\");";
}

function CutScene6_19()
{
Sprite[1].direction = 14;
Sprite[1].frame = 1;
WaitFrames(15);
Sprite[1].direction = 1;
Sprite[1].frame = 3;
WaitFrames(15);

Foreground = true;
CurrentText++;
CurrentName = 1;
Port1 = LoadImage("Port_1.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_20();\");";
}

function CutScene6_20()
{
Foreground = true;
CurrentText++;
CurrentName = 6;
Port1 = LoadImage("Port_6.png");
DoneTextScript = "SetMapDelayScript(1, \"action\", \"CutScene6_21();\");";
}

function CutScene6_21()
{
	for (i=0; i<=2.5*MS; i++)
	{
	SetMapDelayScript(i+MS, "draw", "Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0," + Math.floor(i*255/(2.5*MS)) + ")); SetScale("+(Scale-i*Scale/150)+")");
	}

SetMapDelayScript(Math.floor(3.5*MS)+1, "action", "ExitEngine();");

Sprite[3].advance = true;
MoveSprite(3, "nw", false, true);
/*WaitFrames(Math.floor(MS/2));
Sprite[1].advance = true;
MoveSprite(1, "nw", false, true);
WaitFrames(Math.floor(MS/2));
MoveSprite(3, "nw", false, true);
WaitFrames(Math.floor(MS/2));
MoveSprite(1, "ne", false, true);
WaitFrames(Math.floor(MS/2));
MoveSprite(3, "nw", false, true);
WaitFrames(Math.floor(MS/2));
MoveSprite(1, "ne", false, true);
WaitFrames(Math.floor(MS/2));
MoveSprite(3, "nw", false, true);
*/
WaitFrames(MS);
Sprite[1].advance = true;
MoveSprite(1, "nw", false, true);
MoveSprite(3, "nw", false, true);
WaitFrames(MS);
MoveSprite(1, "ne", false, true);
MoveSprite(3, "nw", false, true);
WaitFrames(MS);
MoveSprite(1, "ne", false, true);
MoveSprite(3, "nw", false, true);
}

function CutScene7()
{
	StartFight(0);
}