var Fight = new Array();
var maxfights = 50;

for (i=0; i<maxfights; i++)
{
Fight[i] = new Array();
}

Fight[0][0] = "Castle3s";//map name (no extensions)
Fight[0][1] = "";//starting script (cutscenes), "" = none
Fight[0][2] = 1;//conditions to win
Fight[0][3] = 1;//conditions to lose

Fight[0][4] = 58;//"player1" starting cube
Fight[0][5] = 3;//"player1" starting direction

Fight[0][6] = 2;//"player2" starting cube
Fight[0][7] = 3;//"player2" starting direction

Fight[0][8] = 3;//"player3" starting cube
Fight[0][9] = 3;//"player3" starting direction

Fight[0][10] = 4;//"player4" starting cube
Fight[0][11] = 3;//"player4" starting direction

Fight[0][12] = 5;//"player5" starting cube
Fight[0][13] = 3;//"player5" starting direction

Fight[0][14] = 6;//"player6" starting cube
Fight[0][15] = 3;//"player6" starting direction

Fight[0][16] = 7;//"player7" starting cube
Fight[0][17] = 3;//"player7" starting direction

Fight[0][20] = 50;//Cube of enemy1
Fight[0][21] = 1;//direction of enemy1
Fight[0][22] = 100;//Enemy Index

Fight[0][23] = 10;//Cube of enemy2
Fight[0][24] = 1;//direction of enemy2
Fight[0][25] = -101;//Enemy Index

Fight[0][26] = 10;//Cube of enemy3
Fight[0][27] = 1;//direction of enemy3
Fight[0][28] = -102;//Enemy Index

Fight[0][29] = 10;//Cube of enemy4
Fight[0][30] = 1;//direction of enemy4
Fight[0][31] = -103;//Enemy Index

Fight[0][32] = 10;//Cube of enemy5
Fight[0][33] = 1;//direction of enemy5
Fight[0][34] = -104;//Enemy Index

Fight[0][35] = 10;//Cube of enemy6
Fight[0][36] = 1;//direction of enemy6
Fight[0][37] = -105;//Enemy Index

Fight[0][38] = 10;//Cube of enemy7
Fight[0][39] = 1;//direction of enemy7
Fight[0][40] = -106;//Enemy Index

var FightNum = 0;

function StartFight(fightnumber)
{
	FightNum = fightnumber;
	ResetSprites();
	ResetSpriteSets();

	for (i=0; i<MaxUnits; i++)
	{
	PlayerIndex[i].hp = -1;
	PlayerIndex[i].maxhp = -1;
	PlayerIndex[i].counter = 100;
	PlayerIndex[i].sprite = -1;
	PlayerIndex[i].speed = 1;
	PlayerIndex[i].name = 52;
	PlayerIndex[i].port = "";
	PlayerIndex[i].team = -1;//0-player, 1-enemy, 2-netural
	PlayerIndex[i].control = -1;//0-player, 1-auto 
	PlayerIndex[i].maxmoves = -1;
	PlayerIndex[i].maxactions = -1;
	}

	LoadMap(Fight[fightnumber][0]);

		//default intro
		if (Fight[fightnumber][1] == "")
		{
			//Load player info
			for (i=0; i<7; i++)
			{
				if (PartyMem[i][1] == true)
				{
					LoadInfo(i+1, PartyMem[i][0], Fight[fightnumber][4+i*2], 
					Fight[fightnumber][5+i*2], 0, Player[PartyMem[i][0]][19]);
				}
			}

			for (i=0; i<10; i++)
			{
				if (Fight[fightnumber][22+3*i] >= 100)
				{
				LoadInfo(7+i+1, Fight[fightnumber][22+3*i], Fight[fightnumber][20+i*3], 
				Fight[fightnumber][21+i*3], 1, Player[Fight[fightnumber][22+i*3]][19]);
				}
			}
		}
		else
		{
		//cutscene intro
			eval(Fight[fightnumber][1]);
		}
	StandardView();
	NextCurrentP();
	EngineMenu();
}



function LoadInfo(player_idx, player, thecube, thedir, team, auto)
{

		PlayerIndex[player_idx].hp = Player[player][6];
		PlayerIndex[player_idx].maxhp = Player[player][7];
		PlayerIndex[player_idx].sp = Player[player][8];
		PlayerIndex[player_idx].maxsp = Player[player][9];
		PlayerIndex[player_idx].moral = Player[player][10];
		PlayerIndex[player_idx].maxmoral = Player[player][11];
		PlayerIndex[player_idx].player = player;

		PlayerIndex[player_idx].counter = 100;
		PlayerIndex[player_idx].sprite = 10+player_idx;

		Sprite[10+player_idx].cube = thecube;
		Cube[thecube].sprite = 10+player_idx;
		Sprite[10+player_idx].index = player_idx;
		Sprite[10+player_idx].fdir = thedir;
		Sprite[10+player_idx].direction = thedir;
		Sprite[10+player_idx].xadd = 0;
		Sprite[10+player_idx].yadd = 0;
		Sprite[10+player_idx].zadd = 0;

		//This needs to be modified
		SetPlayerSpriteSet(Player[player][3], player_idx)
//		SetSpriteSet(player_idx,Player[player][3]);	

		Sprite[10+player_idx].xoff = SpriteSet[Sprite[10+player_idx].spriteset][0][1];
		Sprite[10+player_idx].yoff = SpriteSet[Sprite[10+player_idx].spriteset][0][2];
		Sprite[10+player_idx].yoff2 = 0;
		
		PlayerIndex[player_idx].speed = Player[player][18];
		PlayerIndex[player_idx].name = Player[player][0];
		PlayerIndex[player_idx].port = LoadImage(Player[player][2]);
		PlayerIndex[player_idx].team = team;//0-player, 1-enemy, 2-netural
		PlayerIndex[player_idx].control = auto;//0-player, 1-auto 
		PlayerIndex[player_idx].maxmoves = Player[player][16];
		PlayerIndex[player_idx].maxactions = 1;
		PlayerIndex[player_idx].evade = Player[player][18];
}  

function SetPlayerSpriteSet(spriteset_1, index)
{
var spss_boo = false

	//Check to see if this spriteset is already loaded.
	for (spssi=1; spssi<MaxSpriteSets; spssi++)
	{
		//Spriteset already loaded, just set this to that number
		if (SpriteSet[spssi][0][0] == spriteset_1)
		{
			font.drawText(0,0, spriteset_1);
			FlipScreen();
			GetKey();

			Sprite[10+index].spriteset = spssi;
			SetSpriteSet(10+index, spssi);	

			spss_boo = true;
			break;
		}
		/*
		The loop has reached the end of the spritesets, 
		so this spriteset has to be loaded into memory.*/
		else if (SpriteSet[spssi][0][0] == undefined || SpriteSet[spssi][0][0] == "")
		{
		LoadSpriteSetInfo(spssi, spriteset_1);	
		SetSpriteSet(10+index, spssi);	
		break;
		}
	}
}
