/*
This script contains functions which involve the movement of 
sprites from one cube to another.
*/

var ne = "ne";
var se = "se";
var nw = "nw";
var sw = "sw";

var MaxHeightMove = 1.5;
var old_cube = 0;
var MS = 20;//the number of frames it takes for a default move.

function MoveSprite(sprite, thedir, Camera, thequeue, MoveSpeed)
{
	if (Camera == undefined)
	{
	Camera = false;
	}
CDirR = false;
var CurrentTime = 0;

	Sprite[sprite].xadd = 0;
	Sprite[sprite].yadd = 0;
	Sprite[sprite].zadd = 0;

	if (MoveSpeed == undefined)
		MoveSpeed = MS-1;

	if (thedir == "ne")
	{
		if (Math.abs(PxyzHeight(Cube[Sprite[sprite].cube].x,Cube[Sprite[sprite].cube].y,Cube[Sprite[sprite].cube].z,0,1)) <= MaxHeightMove)
		{
				if (CDir == "d1")
				{
					Sprite[sprite].direction = 3;
					Sprite[sprite].fdir = 3;
					CDirR = true;
				}
				else if (CDir == "d2")
				{
					Sprite[sprite].direction = 2;
					Sprite[sprite].fdir = 3;
				}
				else if (CDir == "d3")
				{
					Sprite[sprite].direction = 1;
					Sprite[sprite].fdir = 3;
					CDirR = true;
				}
				else
				{
					Sprite[sprite].direction = 4;
					Sprite[sprite].fdir = 3;
				}

				var x_diff = 0;
				var y_diff = 1;
				var z_diff = -1*PxyzHeight(Cube[Sprite[sprite].cube].x,Cube[Sprite[sprite].cube].y,Cube[Sprite[sprite].cube].z,0,1);

				//d1 or d4
				if (CDir == "d1" || CDir == "d4")
				{	

					if (thequeue == false || thequeue == undefined)
					{
	
						var mj = 0;
						
						while(mj<MoveSpeed)
						{
						CurrentTime = GetTime();

						Sprite[sprite].xadd = mj*x_diff/MoveSpeed;
						Sprite[sprite].yadd = mj*y_diff/MoveSpeed;
						Sprite[sprite].zadd = mj*z_diff/MoveSpeed;

							if (CurrentTime-LastFrameTime > FrameSec)
							{
								for (fci1=0; fci1<FrameSec; fci1+= (CurrentTime-LastFrameTime))
								{
									if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
									{
									AddFrameAll();
									}
								mj++;
								Frames++;
								}
								LastFrameTime = CurrentTime;
							}

								if (Camera == true)
								{
								CenterCamera(Cube[Sprite[sprite].cube].x+.5 + Sprite[sprite].xadd, Cube[Sprite[sprite].cube].y+.5+ Sprite[sprite].yadd, Cube[Sprite[sprite].cube].z+ Sprite[sprite].zadd+ Cube[Sprite[sprite].cube].height);
								}
							DrawMap();
							FlipScreen();
						}
					
						old_cube = Sprite[sprite].cube;
						Sprite[sprite].cube = PxyzHeightCube;
						Cube[PxyzHeightCube].sprite = sprite; 
						Cube[old_cube].sprite = undefined;
	
						Sprite[sprite].xadd = 0;
						Sprite[sprite].yadd = 0;
						Sprite[sprite].zadd = 0;
					}
					else //this is going though the engine (NextFrame) for drawing
					{
						Sprite[sprite].xadd = 0;
						Sprite[sprite].yadd = 0;
						Sprite[sprite].zadd = 0;

						for (mj = 0; mj<MoveSpeed; mj++)
						{
						SetMapDelayScript(mj, "action", "Sprite["+sprite+"].xadd = "+(mj*x_diff/MoveSpeed)+";");
						SetMapDelayScript(mj, "action", "Sprite["+sprite+"].yadd = "+(mj*y_diff/MoveSpeed)+";");
						SetMapDelayScript(mj, "action", "Sprite["+sprite+"].zadd = "+(mj*z_diff/MoveSpeed)+";");

								if (Camera == true)
								{
									SetMapDelayScript(mj, "action", "CenterCamera(Cube[Sprite["+sprite+"].cube].x+.5 + Sprite["+sprite+"].xadd, Cube[Sprite["+sprite+"].cube].y+.5+ Sprite["+sprite+"].yadd, Cube[Sprite["+sprite+"].cube].z+ Sprite["+sprite+"].zadd+ Cube[Sprite["+sprite+"].cube].height);");
								}
						}
						SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].cube = "+PxyzHeightCube+";");
						SetMapDelayScript(MoveSpeed, "action", "Cube["+PxyzHeightCube+"].sprite = "+sprite+"; ");
						SetMapDelayScript(MoveSpeed, "action", "Cube[" +Sprite[sprite].cube+"].sprite = undefined;");
	
						SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].xadd = 0;Sprite["+sprite+"].yadd = 0;Sprite["+sprite+"].zadd = 0;");
					}
				}
				else
				{
					old_cube = Sprite[sprite].cube;
					Sprite[sprite].cube = PxyzHeightCube;
					Cube[PxyzHeightCube].sprite = sprite; 
					Cube[old_cube].sprite = undefined;

					if (thequeue == false || thequeue == undefined)
					{
						for (mj = MoveSpeed; mj>0; )
						{
							Sprite[sprite].xadd = mj*x_diff/MoveSpeed;
							Sprite[sprite].yadd = -1*mj*y_diff/MoveSpeed;
							Sprite[sprite].zadd = -1*mj*z_diff/MoveSpeed;

							CurrentTime = GetTime();

							if (CurrentTime-LastFrameTime > FrameSec)
							{
								for (fci1=0; fci1<FrameSec; fci1+= (CurrentTime-LastFrameTime))
								{
									if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
									{
									AddFrameAll();
									}
								mj--;
								Frames++;
								}
								LastFrameTime = CurrentTime;
							}

								if (Camera == true)
								{
								CenterCamera(Cube[Sprite[sprite].cube].x+.5 + Sprite[sprite].xadd, Cube[Sprite[sprite].cube].y+.5+ Sprite[sprite].yadd, Cube[Sprite[sprite].cube].z+ Sprite[sprite].zadd+ Cube[Sprite[sprite].cube].height);
								}
							DrawMap();
							FlipScreen();
						}
						Sprite[sprite].xadd = 0;
						Sprite[sprite].yadd = 0;
						Sprite[sprite].zadd = 0;
					}
					else
					{
						Sprite[sprite].xadd = x_diff;
						Sprite[sprite].yadd = -1*y_diff;
						Sprite[sprite].zadd = -1*z_diff;

						for (mj = MoveSpeed; mj>0; mj--)
						{
						SetMapDelayScript((MoveSpeed-mj), "action", "Sprite["+sprite+"].xadd = "+(mj*x_diff/MoveSpeed)+");");
						SetMapDelayScript((MoveSpeed-mj), "action", "Sprite["+sprite+"].yadd = "+(-mj*y_diff/MoveSpeed)+");");
						SetMapDelayScript((MoveSpeed-mj), "action", "Sprite["+sprite+"].zadd = "+(-mj*z_diff/MoveSpeed)+");");

								if (Camera == true)
								{
								SetMapDelayScript((MoveSpeed-mj), "action", "CenterCamera(Cube[Sprite["+sprite+"].cube].x+.5 + Sprite["+sprite+"].xadd, Cube[Sprite["+sprite+"].cube].y+.5+ Sprite["+sprite+"].yadd, Cube[Sprite["+sprite+"].cube].z+ Sprite["+sprite+"].zadd+ Cube[Sprite["+sprite+"].cube].height);");
								}
						}
						SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].xadd = 0;");
						SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].yadd = 0;");
					}
				}
		}
	}
	else if (thedir == "sw")
	{
		if (Math.abs(PxyzHeight(Cube[Sprite[sprite].cube].x,Cube[Sprite[sprite].cube].y,Cube[Sprite[sprite].cube].z,0,-1)) <= MaxHeightMove)
		{
//		if (Pxyz[Cube[Sprite[sprite].cube].x][Cube[Sprite[sprite].cube].y-1][Cube[Sprite[sprite].cube].z] >= 0)
//		{
		//move
			//d1 or d4
			if (CDir == "d1")
			{
				Sprite[sprite].direction = 1;
				Sprite[sprite].fdir = 1;
				CDirR = true;
			}
			else if (CDir == "d2")
			{
				Sprite[sprite].direction = 4;
				Sprite[sprite].fdir = 1;
			}
			else if (CDir == "d3")
			{
				Sprite[sprite].direction = 3;
				Sprite[sprite].fdir = 1;
				CDirR = true;
			}
			else
			{
				Sprite[sprite].direction = 2;
				Sprite[sprite].fdir = 1;
			}
			var x_diff = 0;
			var y_diff = -1;
			var z_diff = -1*PxyzHeight(Cube[Sprite[sprite].cube].x,Cube[Sprite[sprite].cube].y,Cube[Sprite[sprite].cube].z,0,-1);

			if (CDir == "d1" || CDir == "d4")
			{
				old_cube = Sprite[sprite].cube;
				Sprite[sprite].cube = PxyzHeightCube;
				Cube[PxyzHeightCube].sprite = sprite; 
				Cube[old_cube].sprite = undefined;

				if (thequeue == false || thequeue == undefined)
				{
				Sprite[sprite].xadd = x_diff;
				Sprite[sprite].yadd = -1*y_diff;
				Sprite[sprite].zadd = -1*z_diff;

					for (mj = MoveSpeed; mj>0; )
					{
							Sprite[sprite].xadd = mj*x_diff/MoveSpeed;
							Sprite[sprite].yadd = -1*mj*y_diff/MoveSpeed;
							Sprite[sprite].zadd = -1*mj*z_diff/MoveSpeed;

							CurrentTime = GetTime();

							if (CurrentTime-LastFrameTime > FrameSec)
							{
								for (fci1=0; fci1<FrameSec; fci1+= (CurrentTime-LastFrameTime))
								{
									if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
									{
									AddFrameAll();
									}
								mj--;
								Frames++;
								}
								LastFrameTime = CurrentTime;
							}

								if (Camera == true)
								{
								CenterCamera(Cube[Sprite[sprite].cube].x+.5 + Sprite[sprite].xadd, Cube[Sprite[sprite].cube].y+.5+ Sprite[sprite].yadd, Cube[Sprite[sprite].cube].z+ Sprite[sprite].zadd+ Cube[Sprite[sprite].cube].height);
								}
							DrawMap();
							FlipScreen();
					}
					Sprite[sprite].xadd = 0;
					Sprite[sprite].yadd = 0;
					Sprite[sprite].zadd = 0;
				}
				else //this is going though the engine (NextFrame) for drawing
				{
					Sprite[sprite].xadd = x_diff;
					Sprite[sprite].yadd = -1*y_diff;
					Sprite[sprite].zadd = -1*z_diff;
					for (mj = MoveSpeed; mj>0; mj--)
					{
//					SetMapDelayScript(0, "action", "Sprite[sprite].xadd = "+(x_diff*-1)+";");
//					SetMapDelayScript(0, "action", "Sprite[sprite].yadd = "+(y_diff)+";");//-1*y_diff)+";");

					SetMapDelayScript((MoveSpeed-mj), "action", "Sprite["+sprite+"].xadd = "+(mj*x_diff/MoveSpeed)+";");
					SetMapDelayScript((MoveSpeed-mj), "action", "Sprite["+sprite+"].yadd = "+(-mj*y_diff/MoveSpeed)+";");
					SetMapDelayScript((MoveSpeed-mj), "action", "Sprite["+sprite+"].zadd = "+(-mj*z_diff/MoveSpeed)+";");
							if (Camera == true)
							{
								SetMapDelayScript((MoveSpeed-mj), "action", "CenterCamera(Cube[Sprite["+sprite+"].cube].x+.5 + Sprite["+sprite+"].xadd, Cube[Sprite["+sprite+"].cube].y+.5+ Sprite["+sprite+"].yadd, Cube[Sprite["+sprite+"].cube].z+ Sprite["+sprite+"].zadd+ Cube[Sprite["+sprite+"].cube].height);");
							}
					}
					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].xadd = 0;");
					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].yadd = 0;");
					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].zadd = 0;");
				}
			}
			else
			{
				if(thequeue == false || thequeue == undefined)
				{
				Sprite[sprite].xadd = 0;
				Sprite[sprite].yadd = 0;
				Sprite[sprite].zadd = 0;
	
					for (mj = 0; mj<MoveSpeed; )
					{
							Sprite[sprite].xadd = mj*x_diff/MoveSpeed;
							Sprite[sprite].yadd = mj*y_diff/MoveSpeed;
							Sprite[sprite].zadd = mj*z_diff/MoveSpeed;

							CurrentTime = GetTime();

							if (CurrentTime-LastFrameTime > FrameSec)
							{
								for (fci1=0; fci1<FrameSec; fci1+= (CurrentTime-LastFrameTime))
								{
									if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
									{
									AddFrameAll();
									}
								mj++;
								Frames++;
								}
								LastFrameTime = CurrentTime;
							}

								if (Camera == true)
								{
								CenterCamera(Cube[Sprite[sprite].cube].x+.5 + Sprite[sprite].xadd, Cube[Sprite[sprite].cube].y+.5+ Sprite[sprite].yadd, Cube[Sprite[sprite].cube].z+ Sprite[sprite].zadd+ Cube[Sprite[sprite].cube].height);
								}
							DrawMap();
							FlipScreen();
					}
					old_cube = Sprite[sprite].cube;
					Sprite[sprite].cube = PxyzHeightCube;
					Cube[PxyzHeightCube].sprite = sprite; 
					Cube[old_cube].sprite = undefined;

					Sprite[sprite].xadd = 0;
					Sprite[sprite].yadd = 0;
					Sprite[sprite].zadd = 0;
				}
				else //this is going though the engine (NextFrame) for drawing
				{
				Sprite[sprite].xadd = 0;
				Sprite[sprite].yadd = 0;
				Sprite[sprite].zadd = 0;

					for (mj = 0; mj<MoveSpeed; mj++)
					{
						SetMapDelayScript(mj, "action", "Sprite["+sprite+"].xadd = "+(mj*x_diff/MoveSpeed)+";");
						SetMapDelayScript(mj, "action", "Sprite["+sprite+"].yadd = "+(mj*y_diff/MoveSpeed)+";");
						SetMapDelayScript(mj, "action", "Sprite["+sprite+"].zadd = "+(mj*z_diff/MoveSpeed)+";");

							if (Camera == true)
							{
								SetMapDelayScript(mj, "action", "CenterCamera(Cube[Sprite["+sprite+"].cube].x+.5 + Sprite["+sprite+"].xadd, Cube[Sprite["+sprite+"].cube].y+.5+ Sprite["+sprite+"].yadd, Cube[Sprite["+sprite+"].cube].z+ Sprite["+sprite+"].zadd+ Cube[Sprite["+sprite+"].cube].height);");
							}
					}
					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].cube = "+PxyzHeightCube+";");
					SetMapDelayScript(MoveSpeed, "action", "Cube["+PxyzHeightCube+"].sprite = "+sprite+"; ");
					SetMapDelayScript(MoveSpeed, "action", "Cube[" +Sprite[sprite].cube+"].sprite = undefined;");
	
					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].xadd = 0;");
					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].yadd = 0;");
				}
			}
		}
	}
	else if (thedir == "nw")
	{
		if (Math.abs(PxyzHeight(Cube[Sprite[sprite].cube].x,Cube[Sprite[sprite].cube].y,Cube[Sprite[sprite].cube].z,-1,0)) <= MaxHeightMove)
		{
//		if (Pxyz[Cube[Sprite[sprite].cube].x-1][Cube[Sprite[sprite].cube].y][Cube[Sprite[sprite].cube].z] >= 0)
//		{
			//d1 or d2
			if (CDir == "d1")
			{
				Sprite[sprite].direction = 4;
				Sprite[sprite].fdir = 4;
			}
			else if (CDir == "d2")
			{
				Sprite[sprite].direction = 3;
				Sprite[sprite].fdir = 4;
				CDirR = true;	
			}
			else if (CDir == "d3")
			{
				Sprite[sprite].direction = 2;
				Sprite[sprite].fdir = 4;
			}
			else
			{
				Sprite[sprite].direction = 1;
				Sprite[sprite].fdir = 4;
				CDirR = true;	
			}

			var x_diff = 1;
			var y_diff = 0;
			var z_diff = -1*PxyzHeight(Cube[Sprite[sprite].cube].x,Cube[Sprite[sprite].cube].y,Cube[Sprite[sprite].cube].z,-1,0);

			if (CDir == "d1" || CDir == "d2")
			{

				if (thequeue == false || thequeue == undefined)
				{
				Sprite[sprite].xadd = 0;
				Sprite[sprite].yadd = 0;
				Sprite[sprite].zadd = 0;

					for (mj = 0; mj<MoveSpeed; )
					{
						Sprite[sprite].xadd = -1*mj*x_diff/MoveSpeed;
						Sprite[sprite].yadd = mj*y_diff/MoveSpeed;
						Sprite[sprite].zadd = mj*z_diff/MoveSpeed;

						CurrentTime = GetTime();

							if (CurrentTime-LastFrameTime > FrameSec)
							{
								for (fci1=0; fci1<FrameSec; fci1+= (CurrentTime-LastFrameTime))
								{
									if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
									{
									AddFrameAll();
									}
								mj++;
								Frames++;
								}
								LastFrameTime = CurrentTime;
							}

								if (Camera == true)
								{
								CenterCamera(Cube[Sprite[sprite].cube].x+.5 + Sprite[sprite].xadd, Cube[Sprite[sprite].cube].y+.5+ Sprite[sprite].yadd, Cube[Sprite[sprite].cube].z+ Sprite[sprite].zadd+ Cube[Sprite[sprite].cube].height);
								}
							DrawMap();
							FlipScreen();
					}

				old_cube = Sprite[sprite].cube;
				Sprite[sprite].cube = PxyzHeightCube;
				Cube[PxyzHeightCube].sprite = sprite; 
				Cube[old_cube].sprite = undefined;

				Sprite[sprite].xadd = 0;
				Sprite[sprite].yadd = 0;
				Sprite[sprite].zadd = 0;
				}
				else //this is going though the engine (NextFrame) for drawing
				{
				Sprite[sprite].xadd = 0;
				Sprite[sprite].yadd = 0;
				Sprite[sprite].zadd = 0;
				
					for (mj = 0; mj<MoveSpeed; mj++)
					{
						SetMapDelayScript(mj, "action", "Sprite["+sprite+"].xadd = "+(-mj*x_diff/MoveSpeed)+";");
						SetMapDelayScript(mj, "action", "Sprite["+sprite+"].yadd = "+(mj*y_diff/MoveSpeed)+";");
						SetMapDelayScript(mj, "action", "Sprite["+sprite+"].zadd = "+(mj*z_diff/MoveSpeed)+";");

							if (Camera == true)
							{
								SetMapDelayScript(mj, "action", "CenterCamera(Cube[Sprite["+sprite+"].cube].x+.5 + Sprite["+sprite+"].xadd, Cube[Sprite["+sprite+"].cube].y+.5+ Sprite["+sprite+"].yadd, Cube[Sprite["+sprite+"].cube].z+ Sprite["+sprite+"].zadd+ Cube[Sprite["+sprite+"].cube].height);");
							}
					}
					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].cube = "+PxyzHeightCube+";");
					SetMapDelayScript(MoveSpeed, "action", "Cube["+PxyzHeightCube+"].sprite = "+sprite+"; ");
					SetMapDelayScript(MoveSpeed, "action", "Cube[" +Sprite[sprite].cube+"].sprite = undefined;");
	
					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].xadd = 0;");
					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].yadd = 0;");
				}
			}
			else
			{
				old_cube = Sprite[sprite].cube;
				Sprite[sprite].cube = PxyzHeightCube;
				Cube[PxyzHeightCube].sprite = sprite; 
				Cube[old_cube].sprite = undefined;

				if (thequeue == false || thequeue == undefined)
				{
				Sprite[sprite].xadd = 0;
				Sprite[sprite].yadd = 0;
				Sprite[sprite].zadd = 0;
					for (mj = MoveSpeed; mj>0; )
					{
						Sprite[sprite].xadd = mj*x_diff/MoveSpeed;
						Sprite[sprite].yadd = mj*y_diff/MoveSpeed;
						Sprite[sprite].zadd = -1*mj*z_diff/MoveSpeed;

						CurrentTime = GetTime();

							if (CurrentTime-LastFrameTime > FrameSec)
							{
								for (fci1=0; fci1<FrameSec; fci1+= (CurrentTime-LastFrameTime))
								{
									if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
									{
									AddFrameAll();
									}
								mj--;
								Frames++;
								}
								LastFrameTime = CurrentTime;
							}

								if (Camera == true)
								{
								CenterCamera(Cube[Sprite[sprite].cube].x+.5 + Sprite[sprite].xadd, Cube[Sprite[sprite].cube].y+.5+ Sprite[sprite].yadd, Cube[Sprite[sprite].cube].z+ Sprite[sprite].zadd+ Cube[Sprite[sprite].cube].height);
								}
							DrawMap();
							FlipScreen();
					}
				Sprite[sprite].xadd = 0;
				Sprite[sprite].yadd = 0;
				Sprite[sprite].zadd = 0;
				}
				else //this is going though the engine (NextFrame) for drawing
				{
				Sprite[sprite].xadd = x_diff;
				Sprite[sprite].yadd = y_diff;
				Sprite[sprite].zadd = -1*z_diff;

					for (mj = MoveSpeed; mj>0; mj--)
					{
						SetMapDelayScript((MoveSpeed-mj), "action", "Sprite["+sprite+"].xadd = "+(mj*x_diff/MoveSpeed)+";");
						SetMapDelayScript((MoveSpeed-mj), "action", "Sprite["+sprite+"].yadd = "+(mj*y_diff/MoveSpeed)+";");
						SetMapDelayScript((MoveSpeed-mj), "action", "Sprite["+sprite+"].zadd = "+(-mj*z_diff/MoveSpeed)+";");
							if (Camera == true)
							{
								SetMapDelayScript((MoveSpeed-mj), "action", "CenterCamera(Cube[Sprite["+sprite+"].cube].x+.5 + Sprite["+sprite+"].xadd, Cube[Sprite["+sprite+"].cube].y+.5+ Sprite["+sprite+"].yadd, Cube[Sprite["+sprite+"].cube].z+ Sprite["+sprite+"].zadd+ Cube[Sprite["+sprite+"].cube].height);");
							}
					}
					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].xadd = 0;");
					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].yadd = 0;");
				}
			}
		}
	}
	else if (thedir == "se")
	{
		if (Math.abs(PxyzHeight(Cube[Sprite[sprite].cube].x,Cube[Sprite[sprite].cube].y,Cube[Sprite[sprite].cube].z,1,0)) <= MaxHeightMove)
		{
//		if (Pxyz[Cube[Sprite[sprite].cube].x+1][Cube[Sprite[sprite].cube].y][Cube[Sprite[sprite].cube].z] >= 0)
//		{
			//d1 or d2
			if (CDir == "d1")
			{
				Sprite[sprite].direction = 2;
				Sprite[sprite].fdir = 2;
			}
			else if (CDir == "d2")
			{
				Sprite[sprite].direction = 1;
				Sprite[sprite].fdir = 2;
				CDirR = true;
			}
			else if (CDir == "d3")
			{
				Sprite[sprite].direction = 4;
				Sprite[sprite].fdir = 2;
			}
			else
			{
				Sprite[sprite].direction = 3;
				Sprite[sprite].fdir = 2;
				CDirR = true;
			}
			var x_diff = -1;
			var y_diff = 0;
			var z_diff = -1*PxyzHeight(Cube[Sprite[sprite].cube].x,Cube[Sprite[sprite].cube].y,Cube[Sprite[sprite].cube].z,1,0);
		
			if (CDir == "d1" || CDir == "d2")
			{

				old_cube = Sprite[sprite].cube;
				Sprite[sprite].cube = PxyzHeightCube;
				Cube[PxyzHeightCube].sprite = sprite; 
				Cube[old_cube].sprite = undefined;

				if (thequeue == false || thequeue == undefined)
				{

					for (mj = MoveSpeed; mj>0; )
					{
						Sprite[sprite].xadd = mj*x_diff/MoveSpeed;
						Sprite[sprite].yadd = mj*y_diff/MoveSpeed;
						Sprite[sprite].zadd = -1*mj*z_diff/MoveSpeed;

						CurrentTime = GetTime();

							if (CurrentTime-LastFrameTime > FrameSec)
							{
								for (fci1=0; fci1<FrameSec; fci1+= (CurrentTime-LastFrameTime))
								{
									if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
									{
									AddFrameAll();
									}
								mj--;
								Frames++;
								}
								LastFrameTime = CurrentTime;
							}

								if (Camera == true)
								{
								CenterCamera(Cube[Sprite[sprite].cube].x+.5 + Sprite[sprite].xadd, Cube[Sprite[sprite].cube].y+.5+ Sprite[sprite].yadd, Cube[Sprite[sprite].cube].z+ Sprite[sprite].zadd+ Cube[Sprite[sprite].cube].height);
								}
							DrawMap();
							FlipScreen();
					}
				Sprite[sprite].xadd = 0;
				Sprite[sprite].yadd = 0;
				Sprite[sprite].zadd = 0;
				}
				else //this is going though the engine (NextFrame) for drawing
				{
				Sprite[sprite].xadd = x_diff;
				Sprite[sprite].yadd = y_diff;
				Sprite[sprite].zadd = -1*z_diff;

					for (mj = MoveSpeed; mj>0; mj--)
					{
//					SetMapDelayScript(0, "action", "Sprite[sprite].xadd = "+x_diff+";");
//					SetMapDelayScript(0, "action", "Sprite[sprite].yadd = "+(-1*y_diff)+";");

						SetMapDelayScript((MoveSpeed-mj), "action", "Sprite["+sprite+"].xadd = "+(mj*x_diff/MoveSpeed)+";");
						SetMapDelayScript((MoveSpeed-mj), "action", "Sprite["+sprite+"].yadd = "+(mj*y_diff/MoveSpeed)+";");
						SetMapDelayScript((MoveSpeed-mj), "action", "Sprite["+sprite+"].zadd = "+(-mj*z_diff/MoveSpeed)+";");
							if (Camera == true)
							{
								SetMapDelayScript((MoveSpeed-mj), "action", "CenterCamera(Cube[Sprite["+sprite+"].cube].x+.5 + Sprite["+sprite+"].xadd, Cube[Sprite["+sprite+"].cube].y+.5+ Sprite["+sprite+"].yadd, Cube[Sprite["+sprite+"].cube].z+ Sprite["+sprite+"].zadd+ Cube[Sprite["+sprite+"].cube].height);");
							}
					}

					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].xadd = 0;");
					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].yadd = 0;");
				}
			}
			else
			{

				if (thequeue == false || thequeue == undefined)
				{
				Sprite[sprite].xadd = 0;
				Sprite[sprite].yadd = 0;
					for (mj = 0; mj<MoveSpeed; )
					{
						Sprite[sprite].xadd = -1*mj*x_diff/MoveSpeed;
						Sprite[sprite].yadd = mj*y_diff/MoveSpeed;
						Sprite[sprite].zadd = mj*z_diff/MoveSpeed;

						CurrentTime = GetTime();

							if (CurrentTime-LastFrameTime > FrameSec)
							{
								for (fci1=0; fci1<FrameSec; fci1+= (CurrentTime-LastFrameTime))
								{
									if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
									{
									AddFrameAll();
									}
								mj++;
								Frames++;
								}
								LastFrameTime = CurrentTime;
							}

								if (Camera == true)
								{
								CenterCamera(Cube[Sprite[sprite].cube].x+.5 + Sprite[sprite].xadd, Cube[Sprite[sprite].cube].y+.5+ Sprite[sprite].yadd, Cube[Sprite[sprite].cube].z+ Sprite[sprite].zadd+ Cube[Sprite[sprite].cube].height);
								}
							DrawMap();
							FlipScreen();
					}
					Sprite[sprite].xadd = 0;
					Sprite[sprite].yadd = 0;
					Sprite[sprite].zadd = 0;

					old_cube = Sprite[sprite].cube;
					Sprite[sprite].cube = PxyzHeightCube;
					Cube[PxyzHeightCube].sprite = sprite; 
					Cube[old_cube].sprite = undefined;
				}
				else //this is going though the engine (NextFrame) for drawing
				{
				Sprite[sprite].xadd = 0;
				Sprite[sprite].yadd = 0;
				Sprite[sprite].zadd = 0;

					for (mj = 0; mj<MoveSpeed; mj++)
					{
						SetMapDelayScript(mj, "action", "Sprite["+sprite+"].xadd = "+(-mj*x_diff/MoveSpeed)+";");
						SetMapDelayScript(mj, "action", "Sprite["+sprite+"].yadd = "+(mj*y_diff/MoveSpeed)+";");
						SetMapDelayScript(mj, "action", "Sprite["+sprite+"].zadd = "+(mj*z_diff/MoveSpeed)+";");

							if (Camera == true)
							{
								SetMapDelayScript(mj, "action", "CenterCamera(Cube[Sprite["+sprite+"].cube].x+.5 + Sprite["+sprite+"].xadd, Cube[Sprite["+sprite+"].cube].y+.5+ Sprite["+sprite+"].yadd, Cube[Sprite["+sprite+"].cube].z+ Sprite["+sprite+"].zadd+ Cube[Sprite["+sprite+"].cube].height);");
							}
					}
					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].cube = "+PxyzHeightCube+";");
					SetMapDelayScript(MoveSpeed, "action", "Cube["+PxyzHeightCube+"].sprite = "+sprite+"; ");
					SetMapDelayScript(MoveSpeed, "action", "Cube[" +Sprite[sprite].cube+"].sprite = undefined;");

					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].xadd = 0;");
					SetMapDelayScript(MoveSpeed, "action", "Sprite["+sprite+"].yadd = 0;");
				}
			}
		}
	}

	if (Editor == true)
	{
	CurrentCube = Sprite[sprite].cube;
	}

//CenterCamera(Cube[Sprite[sprite].cube].x+.5, Cube[Sprite[sprite].cube].y+.5, Cube[Sprite[sprite].cube].z + Cube[Sprite[sprite].cube].height);
//reset the draw order to the default in case it was changed
}

function ZoneMove(msprite, cube_end) 
{
	var slotZ = OpenFile("../maps/"+MapObject.name + ".mzf");

	var ZMcounter = 0; 

	while(Cube[Sprite[msprite].cube].zone != Cube[cube_end].zone && ZMcounter < 50)
	{
	MoveSpriteFrom(msprite, slotZ.read("Zone"+Cube[Sprite[msprite].cube].zone+"_"+Cube[cube_end].zone, 0), false);
	ZMcounter++;
	}
MoveSpriteFrom(msprite, cube_end, false);
}

function MoveSpriteFrom(msprite, cube_end2, queue)
{
	var they_diff = Cube[cube_end2].y - Cube[Sprite[msprite].cube].y;
	var thex_diff = Cube[cube_end2].x - Cube[Sprite[msprite].cube].x;
	var currentcube = Sprite[msprite].cube;
	var go = true;
	var working = false;

	var yadd = 1;
	var ydir = "ne"; 
	if (they_diff < 0)
	{
	yadd = -1;
	ydir = "sw"; 
	}

	var xadd = 1;
	var xdir = "se"; 
	if (thex_diff < 0)
	{
	xadd = -1;
	xdir = "nw"; 
	}

	if (queue == undefined)
		queue = false;

	for (mi=0; mi<they_diff*yadd; mi++)
	{
		if (PxyzHeight(Cube[currentcube].x, Cube[currentcube].y, Cube[currentcube].z, 0, yadd) >= -100)
		{
		currentcube = PxyzHeightCube;
		}
		else
		{
		go = false;
		break;
		}
	}

	//x_diff
	if (go == true)
	{
		for (mi=0; mi<thex_diff*xadd; mi++)
		{
			if (PxyzHeight(Cube[currentcube].x, Cube[currentcube].y, Cube[currentcube].z, xadd, 0) >= -100)
			{
			currentcube = PxyzHeightCube;
			}
			else
			{
			go = false;
			break;
			}
		}
	}
	
	if (go == true)
	{
		if (queue == true)
		{
		var fcounter = 0;
			for (mi1=0; mi1<they_diff*yadd; mi1++)
			{
			SetMapDelayScript(fcounter*25 + fcounter, "action", "MoveSprite("+msprite+","+ydir+", false);");
			fcounter++;
			//MoveSprite(msprite,ydir, false, false);
			}
			for (mi1=0; mi1<thex_diff*xadd; mi1++)
			{
			SetMapDelayScript(fcounter*25 + fcounter, "action", "MoveSprite("+msprite+","+xdir+", false);");
			fcounter++;
			//MoveSprite(msprite,xdir, false, false);
			}
		}
		else
		{
			for (mi1=0; mi1<they_diff*yadd; mi1++)
			{
			MoveSprite(msprite,ydir, false, false);
			}
			for (mi1=0; mi1<thex_diff*xadd; mi1++)
			{
			MoveSprite(msprite,xdir, false, false);
			}
		}
	return;
	}


	currentcube = Sprite[msprite].cube;
	go = true;
	
	//x_diff
	if (go == true)
	{
		for (mi=0; mi<thex_diff*xadd; mi++)
		{
			if (PxyzHeight(Cube[currentcube].x, Cube[currentcube].y, Cube[currentcube].z, xadd, 0) >= -100)
			{
			currentcube = PxyzHeightCube;
			}
			else
			{
			go = false;
			break;
			}
		}
	}
	for (mi=0; mi<they_diff*yadd; mi++)
	{
		if (PxyzHeight(Cube[currentcube].x, Cube[currentcube].y, Cube[currentcube].z, 0, yadd) >= -100)
		{
		currentcube = PxyzHeightCube;
		}
		else
		{
		go = false;
		break;
		}
	}


	if (go == true)
	{
		if (queue == true)
		{
		var fcounter = 0;
			for (mi1=0; mi1<thex_diff*xadd; mi1++)
			{
			SetMapDelayScript(fcounter*25 + fcounter, "action", "MoveSprite("+msprite+","+xdir+", false);");
			fcounter++;
			//MoveSprite(msprite,xdir, false, false);
			}
			for (mi1=0; mi1<they_diff*yadd; mi1++)
			{
			SetMapDelayScript(fcounter*25 + fcounter, "action", "MoveSprite("+msprite+","+ydir+", false);");
			fcounter++;
			//MoveSprite(msprite,ydir, false, false);
			}
		}
		else
		{
			for (mi1=0; mi1<thex_diff*xadd; mi1++)
			{
			MoveSprite(msprite,xdir, false, false);
			}
			for (mi1=0; mi1<they_diff*yadd; mi1++)
			{
			MoveSprite(msprite,ydir, false, false);
			}
		}
	return;
	}
	//queue moves
}
/*
|_|x|_|_|_|_|_|_|_|_|
|_|_|_|_|0|_|x|_|_|_|
|_|_|x|_|_|_|_|_|x|_|
|x|_|_|_|x|_|_|x|_|_|
|_|_|_|_|_|_|_|_|_|_|
|_|x|x|_|x|_|x|_|x|_|
|_|_|_|x|_|_|_|_|_|_|



*/

var Paths = new Array();

for (i=-11; i<12; i++)
{
Paths[i] = new Array();
	for (j=-11; j<12; j++)
	{
	Paths[i][j] = new Array();
	}
}

/*
Paths[x][y]=12 34;//previous cube that got to this cube (1st two digits = x+11, 2nd two = y+11)
*/
function ResetPaths()
{
	for (si=-11; si<12; si++)
	{
		for (sj=-11; sj<12; sj++)
		{
			for (sk=-11; sk<12; sk++)
			{
			Paths[si][sj][sk] = -1;
			}
		}
	}
}

function SetupPaths(x,y,z, moves, colouridx1, sp)
{
	if (colouridx1 == undefined)
		colouridx1 = 0;

GetPxyz();
var cubes = new Array();
var cubes2 = new Array();
var cubesmax = 50;

	var LastFTime = GetTime();
	var CurrentTime = GetTime();


	for (si = 0; si<cubesmax; si++)
	{
		cubes[si] = new Object();
		cubes2[si] = new Object();
	}

	cubes[0].x = x;
	cubes[0].y = y;
	cubes[0].z = z;

	cubes[1].x = -23;
	cubes[1].y = -23;
	cubes[1].z = -23;

//reset Paths file
	for (si=0; si<CubeNumber; si++)
	{
//		for (sj=-11; sj<12; sj++)
//		{
//			for (sk=-11; sk<12; sk++)
//			{
			
			if (GetTime() - LastFrameTime >= FrameSec)
			{
				if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
				{
				AddFrameAll();
				}
			Frames++;
			LastFrameTime = GetTime();
			DrawMap();
			FlipScreen();
			}
			
	Paths[Cube[si].x][Cube[si].y][Cube[si].z] = -1;
/*			}
			
		if (GetTime() - LastFrameTime >= FrameSec)
		{
		Frames++;
		LastFrameTime = GetTime();
		DrawMap();
		FlipScreen();
		}			

		}
*/}

	Paths[x][y][z] = 0;

	var Ccount = 0;

	for (sm = 0; sm<cubesmax; sm++)
	{
	Ccount = 0;


		for (si=0; si<cubesmax; si++)
		{
			if (cubes2[si].x >-23)
			{
			cubes2[si].x = -23;
			cubes2[si].y = -23;
			cubes2[si].z = -23;
			}
			else
			{
			break;
			}
		}


		for (si=0; si<cubesmax; si++)
		{
//	font.drawText(0,0, cubes[si].x + " " + cubes[0].y);
//	FlipScreen();
//	GetKey();

		if (GetTime() - LastFrameTime >= FrameSec)
		{
				if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
				{
				AddFrameAll();
				}
		Frames++;
		LastFrameTime = GetTime();
		DrawMap();
		FlipScreen();
		}

			if (cubes[si].x > -23 && cubes[si].y > -23)
			{
				if (IsObstruct(cubes[si].x,cubes[si].y,cubes[si].z,-1,0,sp) == false)
				{
					Paths[cubes[si].x-1][cubes[si].y][Cube[PxyzHeightCube].z] = 3;//1;
					cubes2[Ccount].x = cubes[si].x - 1;
					cubes2[Ccount].y = cubes[si].y;
					cubes2[Ccount].z = Cube[PxyzHeightCube].z;
					Ccount++;
					if (sm<moves)
					MarkCube(cubes[si].x-1,cubes[si].y,Cube[PxyzHeightCube].z,colouridx1);
				}
				if (IsObstruct(cubes[si].x,cubes[si].y,cubes[si].z,1,0,sp) == false)
				{
					Paths[cubes[si].x+1][cubes[si].y][Cube[PxyzHeightCube].z] = 1;//3;
					cubes2[Ccount].x = cubes[si].x + 1;
					cubes2[Ccount].y = cubes[si].y;
					cubes2[Ccount].z = Cube[PxyzHeightCube].z;
					Ccount++;
					if (sm<moves)
						MarkCube(cubes[si].x+1,cubes[si].y,Cube[PxyzHeightCube].z,colouridx1);
				}
				if (IsObstruct(cubes[si].x,cubes[si].y,cubes[si].z,0,-1,sp) == false)
				{
					Paths[cubes[si].x][cubes[si].y-1][Cube[PxyzHeightCube].z] = 2;
					cubes2[Ccount].x = cubes[si].x;
					cubes2[Ccount].y = cubes[si].y-1;
					cubes2[Ccount].z = Cube[PxyzHeightCube].z;
					Ccount++;
					if (sm<moves)
						MarkCube(cubes[si].x,cubes[si].y-1,Cube[PxyzHeightCube].z,colouridx1);
				}
				if (IsObstruct(cubes[si].x,cubes[si].y,cubes[si].z,0,1, sp) == false)
				{
					Paths[cubes[si].x][cubes[si].y+1][Cube[PxyzHeightCube].z] = 4;
					cubes2[Ccount].x = cubes[si].x;
					cubes2[Ccount].y = cubes[si].y+1;
					cubes2[Ccount].z = Cube[PxyzHeightCube].z;
					Ccount++;
					if (sm<moves)
						MarkCube(cubes[si].x,cubes[si].y+1,Cube[PxyzHeightCube].z,colouridx1);
				}
				//check left
				//check right
				//check up
				//check down
			}
			else
			{
			break;
			//stop this section
			}

		}
	
		for (si=0; si<22; si++)
		{
			cubes[si].x = -23;
			cubes[si].y = -23;
			cubes[si].z = -23;
		}
		for (si=0; si<22; si++)
		{
			cubes[si].x = cubes2[si].x;
			cubes[si].y = cubes2[si].y;
			cubes[si].z = cubes2[si].z;
		}
		//write info to Paths array
	}
}

function MarkCube(x, y,z, n)
{
	Cube[Pxyz[x][y][z]].pA = n;
}

function ClearCubes()
{
	for (cc = 0; cc<CubeNumber; cc++)
	{
	Cube[cc].pA = -1;
	}
}

function IsObstruct(x1,y1,z1, x2, y2,sp)
{
	if (Math.abs(PxyzHeight(x1,y1,z1,x2,y2, sp)) <= MaxHeightMove)
	{
		if (Paths[x1+x2][y1+y2][Cube[PxyzHeightCube].z] < 0 && Cube[PxyzHeightCube].pic1 >= 0)
		{
		return false;
		}
	}
return true;
}

function GoToCube(x3,y3,z3,the_sprite,GTC_moves, movespeed, cameraboo, autoclear)
{
var move_mem = new Array();
var max_moves = 40;

	if (cameraboo == undefined)
		cameraboo = true;
	if (movespeed == undefined)
		movespeed = 19;

var LastFTime = GetTime();
	for (gti=0; gti<max_moves; gti++)
	{

//			if (GetTime() - LastFTime > FrameSec)
//			{
//			LastFTime = GetTime();
			Frames++;
			TheFrames++;
//				if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
//				{
				DrawMap();
				FlipScreen();
//				}
//			}
	
		if (Pathable(x3,y3,z3,1) == true)
		{
			move_mem[gti] = "se";//nw";	
			x3-=1;
			PxyzHeight(x3,y3,z3,-1,0);
			z3 = Cube[PxyzHeightCube].z;
		}
		else if (Pathable(x3,y3,z3,2) == true)
		{
			move_mem[gti] = "sw";//ne";	
			y3+=1;
			PxyzHeight(x3,y3,z3,0,1);
			z3 = Cube[PxyzHeightCube].z;
		}  
		else if (Pathable(x3,y3,z3,3) == true)
		{
			move_mem[gti] = "nw";//se";	
			x3+=1;
			PxyzHeight(x3,y3,z3,1,0);
			z3 = Cube[PxyzHeightCube].z;
		}  
		else if (Pathable(x3,y3,z3,4) == true)
		{
			move_mem[gti] = "ne";//sw";
			y3-=1;
			PxyzHeight(x3,y3,z3,0,-1);
			z3 = Cube[PxyzHeightCube].z;
		}
		else
		{
		var temp_c = gti;//is this even needed? 
		break;
		}
	}

	var tempy7 = 0;
	for (gt1=temp_c; gt1>= temp_c-GTC_moves; gt1--)
	{
	tempy7 = Sprite[the_sprite].cube;
//	DrawMap();
	MoveSprite(the_sprite, move_mem[gt1], cameraboo, false, movespeed);
		if (tempy7 != Sprite[the_sprite].cube)
			movesleft--;
	}
}

function Pathable(x,y,z, number)
{
	for (pti=0; pti<MaxHeightMove+10; pti++)
	{
		if (Paths[x][y][z+pti] == number)
		 return true;
		else if (Paths[x][y][z-pti] == number)
		 return true;
	}
return false;
}

function GetClosestTo(x4, y4, z4, side, PI)
{
var temp = 0;

//Cube[Sprite[PlayerIndex[CurrentP].sprite].cube].pA = 0;

	while(true)
	{
	if (side == true)
	{
		if (Sprite[PlayerIndex[PI].sprite].fdir == 1)
		{
		PxyzHeight(x4,y4,z4,0,1);
			if (Cube[PxyzHeightCube].pA != -1)
			{
			temp = 1;
			y4+=1;
			break;
			}
		}
		else if (Sprite[PlayerIndex[PI].sprite].fdir == 2)
		{
		PxyzHeight(x4,y4,z4,-1,0);
			if (Cube[PxyzHeightCube].pA != -1)
			{
			temp = 1;
			x4-=1;
			break;
			}
		}
		else if (Sprite[PlayerIndex[PI].sprite].fdir == 3)
		{
		PxyzHeight(x4,y4,z4,0,-1);
			if (Cube[PxyzHeightCube].pA != -1)
			{
			temp = 1;
			y4-=1;
			break;
			}
		}
		else if (Sprite[PlayerIndex[PI].sprite].fdir == 4)
		{
		PxyzHeight(x4,y4,z4,1,0);
			if (Cube[PxyzHeightCube].pA != -1)
			{
			temp = 1;
			x4+=1;
			break;
			}
		}

		if (temp != 1)//check sides
		{
			if (Sprite[PlayerIndex[PI].sprite].fdir == 1 || Sprite[PlayerIndex[PI].sprite].fdir == 3)
			{
			PxyzHeight(x4,y4,z4,-1,0);
				if (Cube[PxyzHeightCube].pA != -1)
				{
				temp = 2;
				x4-=1;
				break;
				}
			PxyzHeight(x4,y4,z4,1,0);
				if (Cube[PxyzHeightCube].pA != -1)
				{
				temp = 2;
				x4+=1;
				break;
				}
			}
			else if (Sprite[PlayerIndex[PI].sprite].fdir == 2 || Sprite[PlayerIndex[PI].sprite].fdir == 4)
			{
			PxyzHeight(x4,y4,z4,0,1);
				if (Cube[PxyzHeightCube].pA != -1)
				{
				temp = 2;
				y4+=1;
				break;
				}
			PxyzHeight(x4,y4,z4,0,-1);
				if (Cube[PxyzHeightCube].pA != -1)
				{
				temp = 2;
				y4-=1;
				break;
				}
			}
		}
	
		if (temp != 1 && temp != 2)
		{
			if (Sprite[PlayerIndex[PI].sprite].fdir == 1)
			{
			PxyzHeight(x4,y4,z4,0,-1);
				if (Cube[PxyzHeightCube].pA != -1)
				{
				temp = 3;
				y4-=1;
				break;
				}
			}
			else if (Sprite[PlayerIndex[PI].sprite].fdir == 2)
			{
			PxyzHeight(x4,y4,z4,1,0);
				if (Cube[PxyzHeightCube].pA != -1)
				{
				temp = 3;
				x4+=1;
				break;
				}
			}
			else if (Sprite[PlayerIndex[PI].sprite].fdir == 3)
			{
			PxyzHeight(x4,y4,z4,0,1);
				if (Cube[PxyzHeightCube].pA != -1)
				{
				temp = 3;
				y4+=1;
				break;
				}
			}
			else if (Sprite[PlayerIndex[PI].sprite].fdir == 4)
			{
			PxyzHeight(x4,y4,z4,-1,0);
				if (Cube[PxyzHeightCube].pA != -1)
				{
				temp = 3;
				x4-=1;
				break;
				}
			}
		}
/*	font.drawText(0,0,"defaulty");
	FlipScreen();
	GetKey();
*/	}
	else
	{
	//check north
	//check west
	//check east
	//check south
	}

		if (Sprite[PlayerIndex[PI].sprite].fdir == 1)
		{
		PxyzHeight(x4,y4,z4,0,1);
		temp = -1;
		y4+=1;
		}
		else if (Sprite[PlayerIndex[PI].sprite].fdir == 2)
		{
		PxyzHeight(x4,y4,z4,-1,0);
		temp = -1;
		x4-=1;
		}
		else if (Sprite[PlayerIndex[PI].sprite].fdir == 3)
		{
		PxyzHeight(x4,y4,z4,0,-1);
		temp = -1;
		y4-=1;
		}
		else if (Sprite[PlayerIndex[PI].sprite].fdir == 4)
		{
		PxyzHeight(x4,y4,z4,1,0);
		temp = -1;
		x4+=1;
		}
		ClearCubes();
		GoToCube(x4, y4, z4, PlayerIndex[CurrentP].sprite, movesleft, BattleMoveSpeed);
		break;
	}


	if (temp != -1)
	{
/*	font.drawText(0,0,x4+" " + y4 + " " + z4);
	FlipScreen();
	GetKey();
*/	z4 = Cube[PxyzHeightCube].z;
	ClearCubes();
	GoToCube(x4, y4, z4, PlayerIndex[CurrentP].sprite, movesleft, BattleMoveSpeed);
	}
}