var Model = new Array();
var ModelTileSet = new Array();

var MaxModels = 10;
var MaxFrames = 10;
var Max = 10;

for (i=0; i<MaxModels; i++)
{
	Model[i] = new Array();
	for (j=0; j<MaxFrames; j++)
	{
		Model[i][j] = new Object();
	}
}

ModelTileSet[0]=1;
ModelTileSet[1]=LoadImage("TreeHalf1.png");

Model[0][0].frames = 1;
Model[0][0].frame = 0;
Model[0][0].squares = 4;

/*KEY:
	point 1  point 2  point 3  point 4
x		q					w				e					r
y		a					s				d					f
z		z					x				c					v

q1 = point q
*/


Model[0][0].q1 = -0.2;
Model[0][0].a1 = 0.5;
Model[0][0].z1 = 4;
Model[0][0].w1 = 0.5;
Model[0][0].s1 = 0.5;
Model[0][0].x1 = 4;
Model[0][0].e1 = 0.5;
Model[0][0].d1 = 0.5;
Model[0][0].c1 = 0;
Model[0][0].r1 = -0.2;
Model[0][0].f1 = 0.5;
Model[0][0].v1 = 0;

Model[0][0].p1 = 1;

Model[0][0].q2 = 0.5;
Model[0][0].a2 = 1.2;
Model[0][0].z2 = 4;
Model[0][0].w2 = 0.5;
Model[0][0].s2 = 0.5;
Model[0][0].x2 = 4;
Model[0][0].e2 = 0.5;
Model[0][0].d2 = 0.5;
Model[0][0].c2 = 0;
Model[0][0].r2 = 0.5;
Model[0][0].f2 = 1.2;
Model[0][0].v2 = 0;

Model[0][0].p2 = 1;

Model[0][0].q3 = 0.5;
Model[0][0].a3 = -0.2;
Model[0][0].z3 = 4;
Model[0][0].w3 = 0.5;
Model[0][0].s3 = 0.5;
Model[0][0].x3 = 4;
Model[0][0].e3 = 0.5;
Model[0][0].d3 = 0.5;
Model[0][0].c3 = 0;
Model[0][0].r3 = 0.5;
Model[0][0].f3 = -0.2;
Model[0][0].v3 = 0;

Model[0][0].p3 = 1;

Model[0][0].q4 = 1.2;
Model[0][0].a4 = 0.5;
Model[0][0].z4 = 4;
Model[0][0].w4 = 0.5;
Model[0][0].s4 = 0.5;
Model[0][0].x4 = 4;
Model[0][0].e4 = 0.5;
Model[0][0].d4 = 0.5;
Model[0][0].c4 = 0;
Model[0][0].r4 = 1.2;
Model[0][0].f4 = 0.5;
Model[0][0].v4 = 0;
Model[0][0].p4 = 1;

Model[0][0].d1_1 = 1;
Model[0][0].d1_2 = 2;
Model[0][0].d1_3 = 3;
Model[0][0].d1_4 = 4;

Model[0][0].d2_1 = 1;
Model[0][0].d2_2 = 2;
Model[0][0].d2_3 = 3;
Model[0][0].d2_4 = 4;

Model[0][0].d3_1 = 3;
Model[0][0].d3_2 = 4;
Model[0][0].d3_3 = 1;
Model[0][0].d3_4 = 2;


Model[0][0].d4_1 = 2;
Model[0][0].d4_2 = 4;
Model[0][0].d4_3 = 1;
Model[0][0].d4_4 = 3;








function DrawModel(model, x,y,z)
{
var sqr = 1;
var mm = Model[model][Model[model][0].frame];
	for (DMi=1; DMi<=mm.squares; DMi++)
	{
	sqr = mm[CDir+"_"+DMi];

		ModelTileSet[mm["p"+sqr]].transformBlit(
		
		ModX_x*(mm["q"+sqr]+x)*TileSize+ModY_x*(mm["a"+sqr]+y)*TileSize-CameraX,
		ModX_y*(mm["q"+sqr]+x)*TileSize+ModY_y*(mm["a"+sqr]+y)*TileSize+ModZ_y*(mm["z"+sqr]+z)*TileSize-CameraY,
		ModX_x*(mm["w"+sqr]+x)*TileSize+ModY_x*(mm["s"+sqr]+y)*TileSize-CameraX,
		ModX_y*(mm["w"+sqr]+x)*TileSize+ModY_y*(mm["s"+sqr]+y)*TileSize+ModZ_y*(mm["x"+sqr]+z)*TileSize-CameraY,
		ModX_x*(mm["e"+sqr]+x)*TileSize+ModY_x*(mm["d"+sqr]+y)*TileSize-CameraX,
		ModX_y*(mm["e"+sqr]+x)*TileSize+ModY_y*(mm["d"+sqr]+y)*TileSize+ModZ_y*(mm["c"+sqr]+z)*TileSize-CameraY,
		ModX_x*(mm["r"+sqr]+x)*TileSize+ModY_x*(mm["f"+sqr]+y)*TileSize-CameraX,
		ModX_y*(mm["r"+sqr]+x)*TileSize+ModY_y*(mm["f"+sqr]+y)*TileSize+ModZ_y*(mm["v"+sqr]+z)*TileSize-CameraY)
	}
}
